unit Unit1;

interface 

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OPT, OPS, OPM, _SYSTEM;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    fFileName: string;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  fStack    : TModList;

implementation

uses OPV, OPL, OPP, OPB, OPA, OPCi386, OPLi386, OPVi386, OPOi386;

{$R *.dfm}

procedure Module(modName: String);
var
  OPS : TScaner;
  n   : integer;
  sym : TToken;
  impName: String;
begin
  if fStack.Find(modName,n) then Exit;
  OPS:= TScaner.Create(modName);
  OPS.Get(sym);
  IF sym=_module THEN OPS.Get(sym) ELSE err(16);
  IF sym = _ident THEN BEGIN
    OPS.Get(sym);
    OPS.CheckSym(sym,_semicolon);
    IF sym = _import THEN BEGIN
      OPS.Get(sym);
      REPEAT
        IF sym = _ident THEN BEGIN
          impName:=OPS.name;
          if (FileExists(impName+moduleext)) then Module(impName+moduleext);
        END;
        OPS.Get(sym);
        IF sym = _becomes THEN BEGIN
          OPS.Get(sym);
          IF sym = _ident THEN BEGIN
            impName:=OPS.Name;
            if (FileExists(impName+moduleext)) then begin
              Module(impName+moduleext);
              OPS.Get(sym);
            end else if impName='SYSTEM' then
              OPS.Get(sym)
            else
              err(152);
          END ELSE
            err(ORD(_ident));
        END ELSE IF sym = _period THEN
          err(200);
        IF      sym = _comma THEN OPS.Get(sym)
        ELSE IF sym = _ident THEN err(ORD(_comma))
        ELSE BREAK;
      UNTIL FALSE;
      OPS.CheckSym(sym,_semicolon);
    END;
  END ELSE
    err(ORD(_ident));
  fStack.Add(modName);
  OPS.Free;
end;

PROCEDURE WriteNode(n: OPT.Nodes);
BEGIN
  IF n.left<>NIL THEN WriteNode(n.left);
  IF n.right<>NIL THEN WriteNode(n.right);
  IF n.link<>NIL THEN WriteNode(n.link);
  OPM.LogWNum(n.clas,4);
END;

PROCEDURE BUILD(S: STRING);
var
  p: OPT.Nodes;
  optn: TSET;
begin
  optn:=DefOpt;

  OPM.OPMBegin;
  OPT.OPTBegin;
  OPL.OPLBegin;

  OPLi386.OPLBegin;
  OPLi386.Init;

  OPV.OPVBegin;
  OPB.OPBBegin;
  OPA.OPABegin;

  breakpc:=0;
  OPM.Init(optn);
  OPV.Init(optn, 0);

  OnewSF := OPM.newsf IN optn;
  OextSF := OPM.extsf IN optn;
  OPP.Module(p, s);
  //OPM.LogW('>'); WriteNode(p); OPM.LogWStr('  <');
  IF OPM.noerr THEN BEGIN
    OPL.Init;
    OPM.errpos.CodePos := 0;
    OPM.FNBegin(S);
    IF OPM.noerr THEN BEGIN
      OPT.OPTExport(S, OnewSF, OextSF);
      OPV.AdrAndSize(OPT.topScope);
      IF OPM.noerr THEN BEGIN
					OPM.errpos.CodePos := 0;
          OPOi386.Init;
          OPCi386.OPCBegin;
					OPCi386.Init;
					OPVi386.Module(p);
					IF OPM.noerr THEN BEGIN
						OPLi386.OutCode(S);
						IF OPM.noerr THEN BEGIN OPM.LogWStr ('   New Obj '); OPM.LogWNum(OPOi386.pcc, 1); OPM.LogWStr (' bytes'); OPM.LogWLn; END;
					END;
      END;

    END;
  END;
  
  OPL.Close;
  OPLi386.Close;
  OPT.CloseScope;       
  OPT.Close;
  p:=NIL;
  //OPT.OBJDestroy;
END;

procedure TForm1.Button1Click(Sender: TObject);
var
  i: integer;
  s: STRING;
begin
  //OPM.ConNoErr    := TRUE;
  //BUILD(fFileName); EXIT;

  fStack:= TModList.Create;
  OPM.ConNoErr    := TRUE;
  Module(fFileName);
  FOR i:=0 TO fStack.count-1 DO BEGIN
    s:=fStack.FindNum(i);
    OPM.LogWLn; OPM.LogWStrLn('Compile "'+ExtractFileName(S)+'"');
    BUILD(s);
  END;
  fStack.Free;
  IF OPM.noerr THEN OPM.LogWStrLn('OK!');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if OpenDialog1.Execute then begin
    Edit1.Text:=OpenDialog1.FileName;
    fFileName:=OpenDialog1.FileName;
    Button1.Enabled:=true;
  end;
end;

end.
