MODULE Console;

IMPORT SYSTEM, Kernel32;

CONST
	length* = 1025;

VAR
	hin, hout: Kernel32.HANDLE;
	text* : ARRAY length OF CHAR;

PROCEDURE Get();
VAR
  adr: Kernel32.ADDRESS; i: LONGINT; ch: CHAR;
BEGIN
  i := 0;
  adr := Kernel32.GetCommandLine();
  REPEAT
	SYSTEM.GET(adr, ch);
	INC(adr);
	text[i] := ch;
    INC(i);
  UNTIL (ch = 0X) OR (i = length);
  IF i < length THEN
    text[i] := ch;
  END;
END Get;

PROCEDURE OpenConsole*;
VAR
 res:LONGINT;
BEGIN
	res := Kernel32.AllocConsole ();
	hin := Kernel32.GetStdHandle (Kernel32.STDInput);
	hout := Kernel32.GetStdHandle (Kernel32.STDOutput);
END OpenConsole;
	
(************************)	
PROCEDURE WriteString*(str:ARRAY OF CHAR);
VAR
	n,i,c:LONGINT;
BEGIN
	n:=LEN(str)-1;
	i:=0;
	WHILE i<=n DO
		c:=ORD(str[i]);
		
		IF (c>=192) & (c<=239)    THEN 
			c:=c-64; 
		ELSIF (c>=240) & (c<=255) THEN 
			c:=c-16;
		ELSIF (c=168)	          THEN 
			c:=240;
		ELSIF (c=184)	          THEN 
			c:=241; 
		END;
		
		str[i]:=CHR(c);
		i:=i+1;
	END;
	Kernel32.WriteFile (hout, str, n, n, NIL);
END WriteString;

(************************)	
PROCEDURE Write*(ch: CHAR);
VAR str: ARRAY 2 OF CHAR;
BEGIN
  str[0] := ch;
  str[1] := 0X;
  WriteString(str)
END Write;

(************************)
PROCEDURE WriteLn*();
VAR str: ARRAY 2 OF CHAR;
BEGIN
  str[0] := 0AX;
  str[1] := 0DX;
  WriteString(str)
END WriteLn;

BEGIN
  OpenConsole();
  Get();
END Console.