MODULE Fonts; (** portable / source: Win32.Fonts.Mod *)	(* ejz   *)
	IMPORT SYSTEM, Modules, Objects;

	CONST
		substitute* = -1; font* = 0; metric* = 1;	(** Font types. *)

	TYPE 
		Font* = POINTER TO FontDesc;

		FontDesc* = RECORD (Objects.LibDesc)
			type*: SHORTINT;	(** Substitute, font, or metric. *)
			height*, minX*, maxX*, minY*, maxY*: INTEGER	(** Font height, extremal values of characters in font. *)
		END;

	VAR
		FontId*: CHAR;	(** Initial character of font files (.Fnt). *)
		Default*: Font;	(** Default system screen font (typically Syntax10.Scn.Fnt). *)

	(** Load and cache a font. *)
	PROCEDURE This*(name: ARRAY OF CHAR): Font;
		VAR L: Objects.Library;
	BEGIN
		L := Objects.ThisLibrary(name);
		IF (L # NIL) & (L IS Font) THEN RETURN L(Font) ELSE RETURN NIL END
	END This;

	PROCEDURE Init();
		VAR mod: Modules.Module;
	BEGIN
		FontId := 0DBX; Default := NIL;
		mod := Modules.ThisMod("WinFonts")
	END Init;

BEGIN
	Init()
END Fonts.