UNIT OER;

INTERFACE

USES
  SysUtils;

TYPE
  TErrorPos = RECORD
    StrPos,CharPoS,CodePos: INTEGER;
  END;

  FUNCTION Errors(N: INTEGER; P: TErrorPos): STRING;

IMPLEMENTATION

USES
  OPM;

FUNCTION Errors(N: INTEGER; P: TErrorPos): STRING;
VAR
  E,S: STRING;
  F: BOOLEAN;
BEGIN
  F:=FALSE;
  IF N<0 THEN BEGIN
    N:=-N;
    F:=TRUE;
  END;

  CASE N OF
    1 :  S:=' multiply defined identifier';
    2 :  S:=' illegal character in number';
    3 :  S:=' illegal character in string';
    4 :  S:=' identifier does not match procedure name';
    5 :  S:=' comment not closed';
    6 :  S:=' ';
    7 :  S:=' ';
    8 :  S:=' ';
    9 :  S:=' "=" expected';
    10 :  S:=' ';
    11 :  S:=' ';
    12 :  S:=' type definition starts with incorrect symbol';
    13 :  S:=' value starts with incorrect symbol';
    14 :  S:=' statement starts with incorrect symbol';
    15 :  S:=' declaration followed by incorrect symbol';
    16 :  S:=' MODULE expected';
    17 :  S:=' ';
    18 :  S:=' "." missing';
    19 :  S:=' "," missing';
    20 :  S:=' ":" missing';
    21 :  S:=' ';
    22 :  S:=' ")" missing';
    23 :  S:=' "]" missing';
    24 :  S:=' "}" missing';
    25 :  S:=' OF missing';
    26 :  S:=' THEN missing';
    27 :  S:=' DO missing';
    28 :  S:=' TO missing';
    29 :  S:=' ';
    30 :  S:=' "(" missing';
    31 :  S:=' ';
    32 :  S:=' ';
    33 :  S:=' ';
    34 :  S:=' ":=" missing';
    35 :  S:=' "," or OF expected';
    36 :  S:=' ';
    37 :  S:=' ';
    38 :  S:=' EXIT not within loop statement';
    39 :  S:=' ';
    40 :  S:=' identifier expected';
    41 :  S:=' ";" missing';
    42 :  S:=' ';
    43 :  S:=' END missing';
    44 :  S:=' ';
    45 :  S:=' ';
    46 :  S:=' UNTIL missing';
    47 :  S:=' illegally marked identifier';
    48 :  S:=' ';
    49 :  S:=' ';
    50 :  S:=' expression should be constant';
    51 :  S:=' constant not an integer';
    52 :  S:=' identifier does not denote a type';
    53 :  S:=' identifier does not denote a record type';
    54 :  S:=' result type of procedure is not a basic type';
    55 :  S:=' procedure call of a function';
    56 :  S:=' assignment to non-variable';
    57 :  S:=' pointer not bound to record or array type';
    58 :  S:=' recursive type definition';
    59 :  S:=' illegal open array parameter';
    60 :  S:=' wrong type of case label';
    61 :  S:=' inadmissible type of case label';
    62 :  S:=' case label defined more than once';
    63 :  S:=' illegal value of constant';
    64 :  S:=' more actual than formal parameters';
    65 :  S:=' fewer actual than formal parameters';
    66 :  S:=' element types of actual array and formal open array differ';
    67 :  S:=' actual parameter corresponding to open array is not an array';
    68 :  S:=' control variable must be integer';
    69 :  S:=' parameter must be an integer constant';
    70 :  S:=' pointer or VAR record required as formal receiver';
    71 :  S:=' pointer expected as actual receiver';
    72 :  S:=' procedure must be bound to a record of the same scope';
    73 :  S:=' procedure must be of level 0';
    74 :  S:=' procedure unknown in base type';
    75 :  S:=' invalid call of base procedure';
    76 :  S:=' this variable (field) is read only';
    77 :  S:=' object is not a record';
    78 :  S:=' dereferenced object is not a variable';
    79 :  S:=' indexed object is not a variable';
    80 :  S:=' index expression is not an integer';
    81 :  S:=' index out of specified bounds';
    82 :  S:=' indexed variable is not an array';
    83 :  S:=' undefined record field';
    84 :  S:=' dereferenced variable is not a pointer';
    85 :  S:=' guard or test type is not an extension of variable type';
    86 :  S:=' guard or testtype is not a pointer';
    87 :  S:=' guarded or tested variable is neither a pointer nor a VAR-parameter record';
    88 :  S:=' open array not allowed as variable, record field or array element';
    89 :  S:=' open lower bound not bound to procedure parameter';
    90 :  S:=' semi-dynamic array not allowed in a record';
    91 :  S:=' ';
    92 :  S:=' operand of IN not an integer, or not a set';
    93 :  S:=' set element type is not an integer';
    94 :  S:=' operand of & is not of type BOOLEAN';
    95 :  S:=' operand of OR is not of type BOOLEAN';
    96 :  S:=' operand not applicable to (unary) +';
    97 :  S:=' operand not applicable to (unary) -';
    98 :  S:=' operand of ~ is not of type BOOLEAN';
    99 :  S:=' ASSERT fault';
    100 :  S:=' incompatible operands of dyadic operator';
    101 :  S:=' operand type inapplicable to *';
    102 :  S:=' operand type inapplicable to /';
    103 :  S:=' operand type inapplicable to DIV';
    104 :  S:=' operand type inapplicable to MOD';
    105 :  S:=' operand type inapplicable to +';
    106 :  S:=' operand type inapplicable to -';
    107 :  S:=' operand type inapplicable to = or #';
    108 :  S:=' operand type inapplicable to relation';
    109 :  S:=' overriding method must be exported';
    110 :  S:=' operand is not a type';
    111 :  S:=' operand inapplicable to (this) function';
    112 :  S:=' operand is not a variable';
    113 :  S:=' incompatible assignment';
    114 :  S:=' string too long to be assigned';
    115 :  S:=' parameter does not match';
    116 :  S:=' number of parameters do not match';
    117 :  S:=' result type does not match';
    118 :  S:=' export mark does not match with forward declaration';
    119 :  S:=' redefinition textually precedes procedure bound to base type';
    120 :  S:=' type of expression following IF, WHILE, UNTIL or ASSERT is not BOOLEAN';
    121 :  S:=' called object is not a procedure (or is an interrupt procedure)';
    122 :  S:=' actual VAR-parameter is not a variable';
    123 :  S:=' type of actual parameter is not identical with that of formal VAR-parameter';
    124 :  S:=' type of result expression differs from that of procedure';
    125 :  S:=' type of case expression is neither INTEGER nor CHAR';
    126 :  S:=' this expression must not be a type or a procedure';
    127 :  S:=' illegal use of object';
    128 :  S:=' unsatisfied forward reference';
    129 :  S:=' unsatisfied forward procedure';
    130 :  S:=' WITH clause does not specify a variable';
    131 :  S:=' LEN not applied to array';
    132 :  S:=' dimension in LEN too large or negative';
    134 :  S:=' initialiser can not return a value';
    135 :  S:=' SYSTEM not imported';
    136 :  S:=' recursive call of operator';
    137 :  S:=' operator not defined';
    138 :  S:=' VAR-parameter not allowed';
    139 :  S:=' multiply-defined operator';
    140 :  S:=' operator not allowed in record scope';
    141 :  S:=' operator type missing';
    142 :  S:=' name does not denote an operator';
    143 :  S:=' invalid number of formal parameters';
    144 :  S:=' only one initializer allowed in a record';
    145 :  S:=' forward declaration not allowed';
    146 :  S:=' operator must use one locally declared argument type';
    147 :  S:=' := operator: cannot be a function';
    148 :  S:=' := operator: first parameter must be VAR';
    150 :  S:=' key inconsistency of imported module';
    151 :  S:=' incorrect symbol file';
    152 :  S:=' symbol file of imported module not found';
    153 :  S:=' object or symbol file not opened (disk full?)';
    154 :  S:=' recursive import not allowed';
    155 :  S:=' generation of new symbol file not allowed';
    170 :  S:=' incompatible assignment (declare the record as POINTER TO RECORD)';

    200 :  S:=' not yet implemented';
    201 :  S:=' lower bound of set range greater than higher bound';
    202 :  S:=' set element greater than MAX(SET) or less than 0';
    203 :  S:=' number too large';
    204 :  S:=' product too large';
    205 :  S:=' division by zero';
    206 :  S:=' sum too large';
    207 :  S:=' difference too large';
    208 :  S:=' overflow in arithmetic shift';
    209 :  S:=' case range too large';
    210 :  S:=' code too long';
    211 :  S:=' procedure too large (reduce procedure size)';
    212 :  S:=' operator should precede procedure declaration';
    213 :  S:=' too many cases in case statement';
    214 :  S:=' ';
    215 :  S:=' not enough registers: simplify expression';
    216 :  S:=' not enough floating-point registers: simplify expression';
    217 :  S:=' ';
    218 :  S:=' illegal value of parameter  "(20 <= p < 256)"';
    219 :  S:=' illegal value of parameter  "(0 <= p < 16)"';
    220 :  S:=' illegal value of parameter';
    221 :  S:=' too many pointers in a record';
    222 :  S:=' too many global pointers';
    223 :  S:=' too many record types';
    224 :  S:=' too many pointer types';
    225 :  S:=' address of pointer variable too large (move forward in text)';
    226 :  S:=' too many exported and/or type-bound procedures';
    227 :  S:=' too many imported modules';
    228 :  S:=' too many exported structures';
    229 :  S:=' too many nested records for import';
    230 :  S:=' too many constants (strings) in module';
    231 :  S:=' too many external and/or type-bound procedures';
    232 :  S:=' too many commands in module';
    233 :  S:=' record extension hierarchy too high';
    234 :  S:=' export of recursive type not allowed';
    235 :  S:=' too many accesses to global variables or constants';
    236 :  S:=' too many exported variables';
    240 :  S:=' identifier too long';
    241 :  S:=' string too long';
    242 :  S:=' address overflow';
    243 :  S:=' too many imported variables';
    247 :  S:=' local variables not allowed in inlined assembler procedure';
    248 :  S:=' PASSIVATE with global condition';
    249 :  S:=' only allowed for POINTER TO RECORDs';
    250 :  S:=' inlined oberon procedures can not be exported';
    251 :  S:=' too many nested function calls';
    252 :  S:=' pointer to this record required';
    253 :  S:=' initialiser must belong to a record';
    254 :  S:=' can not define a static instance of an active object';
    260 :  S:=' Active Oberon forward reference';
    261 :  S:=' Active Oberon method';
    262 :  S:=' Active Oberon relaxed declaration order';
    270 :  S:=' Oberon X structured return type';
    271 :  S:=' Oberon X array';
    280 :  S:=' duplicate fingerprint';

    301 :  S:=' implicit type cast';
    302 :  S:=' guarded variable can be side-effected';
    303 :  S:=' SYSTEM.PTR var parameter output-only';
    304 :  S:=' SYSTEM.VAL size mismatch';
    305 :  S:=' only open arrays and named types can be used';
    306 :  S:=' possible size mismatch';
    310 :  S:=' ambigous operator';
    311 :  S:=' dynamic array deep copy';
    312 :  S:=' implicit reference to heap object via VAR';

    500 :  S:=' undeclared identifier';
    501 :  S:=' addressing mode not allowed';
    502 :  S:=' undefined instruction';
    503 :  S:=' number to large';
    504 :  S:=' max one segment override allowed';
    505 :  S:=' register expected';
    506 :  S:=' 32-Bit register expected';
    507 :  S:=' "[" expected';
    508 :  S:=' scale factor expected (2, 4, 8)';
    509 :  S:=' index already defined';
    510 :  S:=' Carriage Return expected';
    511 :  S:=' Operand missing';
    512 :  S:=' Undefined operand size';
    513 :  S:=' string expected';
    514 :  S:=' Object Type not supported';
    515 :  S:=' Instruction not supported on target';
    516 :  S:=' no target specified';
    517 :  S:=' access to non-local variables not allowed in exported inlined procedure';

    900 :  S:=' never used';
    901 :  S:=' never set';
    902 :  S:=' used before set';
    903 :  S:=' set but never used';
    904 :  S:=' used as varpar, possibly not set';
    905 :  S:=' also declared in outer scope';
    906 :  S:=' access/assignment to intermediate';
    907 :  S:=' redefinition';
    908 :  S:=' new definition';
    909 :  S:=' statement after RETURN/EXIT';
    910 :  S:=' for loop variable set';
    911 :  S:=' implied type guard in record assignment';
    912 :  S:=' call might depend on evaluation sequence of params';
    913 :  S:=' parameter never used';
  ELSE
    S:='';
  END;

  IF F THEN E:=' Warning!!!' ELSE E:=' Error!';
  RESULT:=ExtractFileName(OPM.modulename)+' '+E+'['+IntToStr(N)+'] Str['+IntToStr(P.StrPos)+':'+IntToStr(P.CharPos)+' Pos: '+IntToStr(P.CodePos-2)+'] - "'+S+'"';
  OPM.LogWStrLn(RESULT);
END;

end.
