UNIT OPT;	(* non-portable *)

INTERFACE

USES
  Classes, OPM, OPS, OER, _SYSTEM,
  SYSUTILS;

CONST
  TraceFP = FALSE;
	
  MaxConstLen = OPS.MaxStrLen;
  DefMaxImport=64;
  DefMaxStruct=32;
  DefMaxReimp=32;

  HdPtrName = '@ptr';
  ObjBody = '@Body';

(* object modes *)
  omVar = 1; omVarPar = 2; omCon = 3; omFld = 4; omTyp = 5;
  omLProc = 6; omXProc = 7; omSProc = 8; omCProc = 9; omIProc = 10;
  omMod = 11; omHead = 12; omTProc = 13; omAlias=14;
  omOperator = 15;	(* used only in exp, when the list is created *)
  omReg = 15; omAbs = 16; omRegRel = 17; omCoc = 18;

(* structure forms *)
  sfUndef = 0; sfByte = 1; sfBool = 2; sfChar = 3; sfSInt = 4; sfInt = 5; sfLInt = 6;
  sfReal = 7; sfLReal = 8; sfSet = 9; sfString = 10; sfNilTyp = 11; sfNoTyp = 12;
  sfPointer = 13; sfProcTyp = 14; sfComp = 15;
  sfHInt = 16;

	intSet  = [sfSInt..sfLInt];
  realSet = [sfReal, sfLReal];

  (* composite structure forms *)
  csBasic = 1; csStaticArr = 2; csSDynArr = 3; csDynArr = 4; csOpenArr = 5; csRecord = 6;
  ArraySet = [csStaticArr, csSDynArr, csDynArr, csOpenArr];

(* nodes classes *)
  Nvar = 0; Nvarpar = 1; Nfield = 2; Nderef = 3; Nindex = 4; Nguard = 5; Neguard = 6;
  Nconst = 7; Ntype = 8; Nproc = 9; Nupto = 10; Nmop = 11; Ndop = 12; Ncall = 13;
  Ninittd = 14; Nif = 15; Ncaselse = 16; Ncasedo = 17; Nenter = 18; Nassign = 19;
  Nifelse = 20; Ncase = 21; Nwhile = 22; Nrepeat = 23; Nloop = 24; Nexit = 25;
  Nreturn = 26; Nwith = 27; Ntrap = 28; Nassembler = 29; Ncode = 30; Nfixup = 31;
	Nfinally = 40; Nret = 32;
  	
(*function number*)
  assignfn = 0;
  haltfn = 0; newfn = 1; absfn = 2; capfn = 3; ordfn = 4;
  entierfn = 5; oddfn = 6; minfn = 7; maxfn = 8; chrfn = 9;
  shortfn = 10; longfn = 11; sizefn = 12; incfn = 13; decfn = 14;
  inclfn = 15; exclfn = 16; lenfn = 17; copyfn = 18; ashfn = 19; assertfn = 32;
		
  awaitfn = 64; lockfn = 66;
		
(*SYSTEM function number*)

  adrfn = 20; ccfn = 21; lshfn = 22; rotfn = 23;
  getfn = 24; putfn = 25; getrfn = 26; putrfn = 27;
  bitfn = 28; valfn = 29; sysnewfn = 30; movefn = 31;
  stifn = 33; clifn = 34; poutfn = 35; pinfn = 36;
  shalt = 37;
  get8fn = 38; get16fn = 39; get32fn = 40;
  put8fn = 41; put16fn = 42; put32fn = 43;
  typefn = 44;
		
(* module visibility of objects *)
  internal = 0; external = 1; externalR = 2; internalR = 3;

(* Object flags *)
  hasBody = 1; isRedef = 2; slNeeded = 3; protectedObj = 4;
  activeObj = 5; locked =6; guarded = 7; safe = 8; asmProc = 7;
  typeVisible = 8;	(*this type can be used and allocated, because exported (though strobj is not)*)
  operatorFlag = 8;
  
  checkOverwriting = 31;
  
  (*object trace modes*)
  used = 1; param = 3;

(*symbol tags*)
  SFtypBool=$01; SFtypChar=$02; SFtypSInt=$03;
  SFtypInt=$04; SFtypLInt=$05; SFtypHInt=$06;
  SFtypReal=$07; SFtypLReal=$08; SFtypSet=$09;
  SFtypString=$0A; SFtypNoTyp=$0B; SFtypNilTyp=$0C;
  SFtypByte=$0D; SFtypptr=$0E; SFlastStruct = $0E;
  SFmod1=$0F; SFmod31=$2C; SFmodOther=$2D;
  SFtypOpenArr=$2E; SFtypDynArr=$2F; SFtypArray=$30;
  SFtypPointer=$31; SFtypRecord=$32; SFtypProcTyp=$33;
  SFsysflag=$34; SFinvisible=$35; SFreadonly=$36;
  SFobjflag = $37;	SFconst=$37; SFvar=$38;
  SFlproc=$39; SFxproc=$3A; SFoperator=$3B;
  SFtproc=$3C; SFcproc=SFtproc;	(* same tag, always used in different contexts *)
  SFalias=$3D; SFtyp=$3E; SFend=$3F;

(* history *)
  inserted = 0;	same = 1;	removed = 3;	modified = 4;

  notag = 1; stdcall = 2; winapi = 2; cdecl = 3; untraced = 4;

  (*SYSTEM*)
  yadr = 24; ycc = 25; ybit = 26; ylsh = 27; yrot = 28; yval = 29;
  yget8 = 30; yget16 = 31; yget32 = 32; ytype = 34;

  (* symbol values or ops *)
  vtimes = 1; vslash = 2; vdiv = 3; vmod = 4;
  vand = 5; vplus = 6; vminus = 7; vor = 8; veql = 9;
  vneq = 10; vlss = 11; vleq = 12; vgtr = 13; vgeq = 14;
  vin = 15; vis = 16; vash = 17; vmsk = 18; vlen = 19;
  vconv = 20; vabs = 21; vcap = 22; vodd = 23; vnot = 33;
  vassign = 0;

  FTarget = 1; FExpr = 2; FAssign = 3; FCall = 4; FCond = 5; 
  FParam = 6; FPassExpr = 7; FReturn = 9;

TYPE
  Objects   = CLASS;
  Modules   = CLASS;
  Structs   = CLASS;
  Nodes     = CLASS;
  ConstExts = STRING;

  Consts    = ^ConstDesc;
  ConstDesc = RECORD
    ext     : ConstExts;	(* string or code for code proc *)
    code    : ARRAY [0..OPS.MaxStrLen] OF CHAR;
    intval  : LONGINT;	(* constant value or adr, proc par size, text position or least case label *)
    intval2 : LONGINT;	(* string length, proc var size or larger case label *)
    setval  : TSET;	(* constant value, procedure body present or 'ELSE' present in case *)
    realval : DOUBLE;	(* real or DOUBLE constant value *)
    errpos  : TErrorPos;
  END;

  Objects = CLASS
    left, right, link, scope: Objects;
    myscope: Objects;
    link2, old: Objects;		(* <- old used symbol file comparison *)
    prio, sysflag: SHORTINT;
    code: Nodes;
    name: STRING;
    leaf: BOOLEAN;
    mode, mnolev: SHORTINT;	(* mnolev < 0 -> mno = -mnolev *)
    vis: SHORTINT;	(* 0: internal; 1: external; 2: externalR *)
    typ: Structs;
    conval: Consts;
    adr, linkadr: LONGINT;
    nxtobj, sibling: Objects;
    par: BOOLEAN;
    inited, used: BOOLEAN;
    fp: LONGINT;
    history: SHORTINT;
    errpos: OER.TErrorPos;
    flag: TSET;
  END ;

  StructArr = ARRAY OF Structs;
  ModArr    = ARRAY OF Modules;

  Modules=CLASS(Objects)
    publics: Objects;
    directImp: BOOLEAN;
    nofimp: INTEGER;
    import: ModArr;
    nofstr: INTEGER;
    struct: StructArr;
    nofreimp: INTEGER;
    reimp: StructArr;
  END;

  Structs = CLASS
    form, comp, mno, extlev: SHORTINT;
    ref: INTEGER;
    align, sysflag: SHORTINT;
    rectest, n, size, tdadr, offset: LONGINT;
    txtpos, txtpos2: TErrorPos;
    BaseTyp: Structs;
    link, strobj: Objects;
    fpdone, sref, oref: INTEGER;
    pvused, pbused: BOOLEAN;
    fp, pvfp, pbfp: LONGINT;
    incomplete: BOOLEAN;	(* structure not checked for consistency *)
    ptr: Structs;
    errpos: TErrorPos;
  END ;
		
  Nodes = CLASS
    left, right, link: Nodes;
    clas, subcl: SHORTINT;
    readonly: BOOLEAN;
    typ: Structs;
    obj: Objects;
    conval: Consts;
    global: BOOLEAN;
    up, down: Nodes;
    ref: LONGINT;
    flag, subflg: SHORTINT	(*Backend*)
  END ;
		
VAR
  topScope, objectsx: Objects;
  undftyp, bytetyp, booltyp, chartyp, sinttyp, inttyp, linttyp, hinttyp,
  realtyp, lrltyp, settyp, stringtyp, niltyp, notyp, ptrtyp: Structs;

  SYSimported: BOOLEAN;
  nofmod: SHORTINT;
  modulesx: ModArr;	(*global for each module being compiled*)
  nofemod: SHORTINT;
  modNo: INTEGER;	(*global for each module being compiled*)
  universe, syslink: Objects;
		
  strucForm: ARRAY [0..SFtypProcTyp+1] OF SHORTINT;	(*forms of structures*)
  strucComp: ARRAY [0..SFtypProcTyp+1] OF SHORTINT;	(*forms of structures*)
  predefStruct: ARRAY [0..SFlastStruct+1] OF Structs;	(*predefined types*)
  strucFormSF: ARRAY [0..sfComp+1] OF SHORTINT;	(*forms of structures*)
  strucCompSF: ARRAY [0..sfComp+1] OF SHORTINT;	(*forms of structures*)

  export: BOOLEAN;
  exp: ARRAY [0..sfOperator+1] OF Objects;
  nofstruc: INTEGER;
  OnewSF, OextSF, symNew, symExtended, sfpresent, impSelf, expGlobal: BOOLEAN;
  typSize: PROCEDURE (typ: Structs; allocDesc: BOOLEAN);
  ToBeFixed: Structs;

  PROCEDURE OPTExport(VAR modName: STRING; VAR newsf, extsf: BOOLEAN);
  PROCEDURE Import(VAR aliasName, impName, selfName: STRING);
  PROCEDURE Init(VAR name: STRING);
  PROCEDURE FindInScope(name: STRING; scope: Objects; VAR res: Objects);

  PROCEDURE MarkType(typ: Structs);
  PROCEDURE MarkObj(obj: Objects);
  
  FUNCTION  NewMod(): Modules;
  FUNCTION  NewConst(): Consts;
  FUNCTION  NewObj(): Objects;
  FUNCTION  NewNode(Aclass: SHORTINT): Nodes;
  FUNCTION  NewExt(): STRING;

  FUNCTION  Resolve(VAR name: STRING; VAR x, y: Nodes): Objects;
  PROCEDURE FindField(VAR name: STRING; typ: Structs; VAR res: Objects; mark: BOOLEAN);
  PROCEDURE Find(OPSname: STRING; VAR res: Objects);
  PROCEDURE FindImport(OPSname: STRING; Amod: Objects; VAR res: Objects);

  PROCEDURE FPrintTyp(typ: Structs);
  PROCEDURE FPrintObj(obj: Objects);
  
  PROCEDURE Insert(name: STRING; VAR obj: Objects);
  FUNCTION  NewStr(form, comp: SHORTINT): Structs;
  PROCEDURE OpenScope(level: SHORTINT; owner: Objects);
  PROCEDURE CloseScope;
  PROCEDURE Contextualize(VAR sentinel: Objects);

  PROCEDURE TraverseObjects(top: Objects);
  PROCEDURE Close;
  PROCEDURE OPTBegin;
  
IMPLEMENTATION

PROCEDURE err(n: INTEGER);
BEGIN
  OPM.err(n)
END;
	
PROCEDURE Close;	(* garbage collection *)
VAR
  i: INTEGER;
BEGIN
  topScope:=NIL;
  objectsx:=NIL;
  i:=0; WHILE i<LENGTH(modulesx) DO BEGIN modulesx[i]:=NIL; INC(i) END;
  i:=0; WHILE i<omAlias+1 DO BEGIN exp[i]:=NIL; INC(i) END;
  nofmod:=0;
  nofemod:=0;
END;

FUNCTION NewMod(): Modules;
VAR
  M: Modules;
BEGIN
  M:=Modules.Create;
  M.publics:=NIL;
  M.left:=NIL;
  M.right:=NIL;
  M.link:=NIL;
  M.scope:=NIL;
  M.myscope:=NIL;
  M.link2:=NIL;
  M.old:=NIL;
  M.code:=NIL;
  M.typ:=NIL;
  M.conval:=NIL;
  M.nxtobj:=NIL;
  M.sibling:=NIL;
  SETLENGTH(M.struct, DefMaxStruct);
  SETLENGTH(M.reimp, DefMaxReimp);
  SETLENGTH(M.import, DefMaxImport);
  RESULT:= M;
END;

FUNCTION NewConst(): Consts;
VAR
  Aconst: Consts;
BEGIN
  NEW(Aconst);
  Aconst.ext     := #9;
  Aconst.setval  := [];
  Aconst.intval  :=0;
  Aconst.intval2 :=0;
  Aconst.realval :=0;
  RESULT:=Aconst;
END;

FUNCTION NewObj(): Objects;
VAR
  obj: Objects;
BEGIN
  obj:=Objects.Create;
  obj.left:=NIL;
  obj.right:=NIL;
  obj.link:=NIL;
  obj.scope:=NIL;
  obj.myscope:=NIL;
  obj.link2:=NIL;
  obj.old:=NIL;
  obj.code:=NIL;
  obj.typ:=NIL;
  obj.conval:=NIL;
  obj.nxtobj:=NIL;
  obj.sibling:=NIL;
  obj.errpos := OPM.errpos;
  RESULT:=obj
END;
	
FUNCTION NewStr(form, comp: SHORTINT): Structs;
VAR
  typ: Structs;
BEGIN
  typ:=Structs.Create;
  typ.ptr:=NIL;
  typ.link:=NIL;
  //typ.strobj:=NIL;
  typ.form:=form;
  typ.comp:=comp;
  typ.mno:=0;
  typ.ref:=0;
  typ.sysflag:=0;
  typ.extlev:=0;
  typ.n:=0;
  typ.size:=-1;
  typ.tdadr := OPM.TDAdrUndef;
  typ.offset := OPM.TDAdrUndef;
  typ.txtpos := OPM.errpos;
  typ.BaseTyp := undftyp;
  RESULT:=typ
END;

FUNCTION NewNode(Aclass: SHORTINT): Nodes;
VAR
  node: Nodes;
BEGIN
  node:=Nodes.Create;
  node.left:=NIL;
  node.right:=NIL;
  node.link:=NIL;
  node.typ:=NIL;
  node.obj:=NIL;
  node.conval:=NIL;
  node.up:=NIL;
  node.down:=NIL;
  node.clas := Aclass;
  RESULT:=node;
END;
	
FUNCTION NewExt(): STRING;
VAR
  ext: STRING;
BEGIN
  ext:=#9; //!!!***
  RESULT:=ext;
END;

PROCEDURE DoubleStructArr(VAR x: StructArr);
VAR
  i: LONGINT;
  h: StructArr;
BEGIN
  i := LENGTH(x);
  h := x;
  SETLENGTH(x, 2*i);
  ASSERT(x <> NIL);
  SYSTEM.MOVE(h[0],x[0],i*SIZEOF(Structs));
END;

PROCEDURE DoubleModArr(VAR x: ModArr);
VAR
  i: LONGINT;
  h: ModArr;
BEGIN
  i := LENGTH(x);
  h := x;
  SETLENGTH(x, 2*i);
  ASSERT(x<> NIL);
  SYSTEM.MOVE(h[0],x[0],i*SIZEOF(Modules));
END;

PROCEDURE MarkObj(obj: Objects);
BEGIN
  IF obj<>NIL THEN BEGIN
    obj.used:=TRUE;
    IF obj.mnolev<0 THEN modulesx[-obj.mnolev].used:=TRUE;
  END;
END;

PROCEDURE MarkType(typ: Structs);
BEGIN
  typ.pvused:=TRUE;
  MarkObj(typ.strobj);
END;

PROCEDURE TraverseObjects(top: Objects);
VAR
  flag: TSET;
  Atype: Structs;
BEGIN
  IF top <> NIL THEN BEGIN
    TraverseObjects(top.left);
    IF (top.mode IN [omVar, omVarPar, omFld, omCon, omTyp, omLProc, omTProc, omCProc, omMod])
    AND (top.vis = internal) AND (top.name <> '@SELF') THEN BEGIN
      flag := top.flag * [used, param];
      IF (flag = [param]) THEN
        OPM.Mark(-913, top.errpos)
      ELSe IF (flag = []) THEN
        OPM.Mark(-900, top.errpos);
    END;
    IF (top.mode IN [omLProc, omXProc, omTProc]) THEN TraverseObjects(top.scope.right);
    Atype := top.typ;
    WHILE (Atype.form = sfPointer) OR (Atype.comp = csStaticArr) DO Atype := Atype.BaseTyp;
    IF (Atype.comp = csRecord) AND (Atype.mno = 0) AND (Atype.rectest <> MAX(_LONGINTS)) THEN BEGIN
      Atype.rectest := MAX(_LONGINTS);		(*avoid double checking*)
      TraverseObjects(Atype.link)
    END;
    TraverseObjects(top.right);
  END;
END;
	
PROCEDURE FindImport(OPSname: STRING; Amod: Objects; VAR res: Objects);
VAR
  obj: Objects;
BEGIN
  obj := Amod.scope;
  REPEAT
    IF obj = NIL THEN BREAK;
    IF OPSname < obj.name THEN
      obj := obj.left
    ELSE IF OPSname > obj.name THEN
      obj := obj.right
    ELSE BEGIN(*found*)
      IF (obj.mode = omTyp) and (obj.vis = internal) THEN
        obj := NIL
      ELSE
        MarkObj(obj);
      BREAK;
    END;
  UNTIL FALSE;
  res := obj;
END;

PROCEDURE FindField(VAR name: STRING; typ: Structs; VAR res: Objects; mark: BOOLEAN);
VAR
  obj: Objects;
BEGIN
  res:=NIL;
  WHILE ((typ <> NIL) AND (typ <> ToBeFixed) AND (typ <> undftyp)) AND (res=NIL) DO BEGIN
    obj := typ.link;
    WHILE obj <> NIL DO BEGIN
      IF name < obj.name THEN
        obj := obj.left
      ELSE IF name > obj.name THEN
        obj := obj.right
      ELSE BEGIN (*found*)
        INCL(obj.flag, used);
        res := obj; obj:=NIL
      END
    END ;
    IF (res <> NIL) AND (res.mode = omTProc) AND (res.mnolev <0) AND (res.vis = internal) THEN res := NIL;
    IF res=NIL THEN BEGIN
      IF (typ.BaseTyp<>NIL) AND (typ.BaseTyp<>ToBeFixed) AND (typ.BaseTyp.strobj.vis=internal) AND mark THEN MarkObj(typ.strobj);	(* mfix *)
      typ := typ.BaseTyp;
    END
  END ;
  IF res = NIL THEN EXIT;
  IF mark THEN BEGIN
    res.used:=TRUE;
    MarkObj(typ.strobj);
    typ.pbused:=TRUE
  END;	(* mfix *)
END;

PROCEDURE FindInScope(name: STRING; scope: Objects; VAR res: Objects);
VAR
  obj, head: Objects;
  inRec: BOOLEAN;
BEGIN
  head := scope;
  inRec := FALSE;
  REPEAT
    IF (head.link<>NIL)AND(head.link.mode=omTyp) THEN	BEGIN(*inside a record*)
      FindField(name, head.link.typ, obj, TRUE);
      IF inRec AND (obj <> NIL) AND NOT (obj.mode IN [omTyp, omCon]) THEN  err(200);	(*a record inside a record, cannot access its fields/methods*)
      inRec := TRUE;
      IF (obj <> NIL) OR head.link.typ.incomplete THEN BREAK;
    END ELSE BEGIN
      obj := head.right;
      REPEAT
        IF obj = NIL THEN BREAK;
        IF name < obj.name THEN
          obj := obj.left
        ELSE IF name > obj.name THEN
          obj := obj.right
        ELSE BEGIN(*found*)
          IF inRec AND (head.link <> NIL) AND (head.link.mode <> omMod)
          AND NOT (obj.mode IN [omTyp, omCon]) THEN err(200);	(*record accesses proc vars: illegal*)
          INCL(obj.flag, used);
          BREAK;
        END;
      UNTIL FALSE;
      IF obj <> NIL THEN BREAK;
    END;
    head := head.left;
    IF head = NIL THEN BREAK;
  UNTIL FALSE ;
  IF (obj <> NIL) AND (obj.mode < 0) THEN obj := NIL;
  res := obj;
END;

PROCEDURE Find(OPSname: STRING; VAR res: Objects);
BEGIN
  FindInScope (OPSname, topScope, res)
END;

PROCEDURE Insert(name: STRING; VAR obj: Objects);
VAR
  ob0, ob1: Objects;
  left: BOOLEAN;
BEGIN
  ob0 := topScope;
  ob1 := ob0.right;
  left := FALSE;
  REPEAT
    IF ob1 <> NIL THEN BEGIN
      IF name < ob1.name THEN BEGIN
        ob0 := ob1;
        ob1 := ob0.left;
        left := TRUE
      END ELSE IF name > ob1.name THEN BEGIN
        ob0 := ob1;
        ob1 := ob0.right;
        left := FALSE
      END ELSE BEGIN
        IF (ob1.prio<126) THEN BEGIN	(* not an Operator: obj already exists and not unique*)
          err(1);
          ob0 := ob1;
          ob1 := ob0.right
        END ELSE
          BREAK;
      END;
    END ELSE BEGIN(*insert*)
      ob1:=NewObj();
      ob1.leaf := TRUE;
      IF left THEN ob0.left := ob1 ELSE ob0.right := ob1;
      ob1.left:=NIL;
      ob1.right:=NIL;
      ob1.name:=name;
      ob1.mnolev := topScope.mnolev;
      BREAK;
    END
  UNTIL FALSE;
  obj := ob1;
END;

PROCEDURE CopyOp(VAR new, obj: Objects);
BEGIN
  new.link:=obj.link;
  new.scope:=obj.scope;
  new.prio:=obj.prio;
  new.code:=obj.code;
  new.name:=obj.name;
  new.leaf:=obj.leaf;
  new.mode:=obj.mode;
  new.mnolev:=obj.mnolev;
  new.vis:=obj.vis;
  new.typ:=obj.typ;
  new.conval:=obj.conval;
END;
	
FUNCTION IsExtern(obj: Objects): BOOLEAN;
VAR
  res: Objects;
BEGIN
  IF obj.typ.strobj <> NIL THEN BEGIN
    FindInScope(obj.typ.strobj.name, topScope, res);
    FindInScope(obj.typ.strobj.name, universe, obj)
  END;
  RESULT:=(res <> NIL) AND (res = obj);
END;

FUNCTION CheckCardinality(VAR name: STRING; nofp: SHORTINT): BOOLEAN;
BEGIN
  CASE name[1] OF
     '+', '-': RESULT:= (nofp=1) OR (nofp=2);
     '~'     : RESULT:= (name[2]=#0) AND (nofp=1);
  ELSE
    RESULT:= nofp=2;
  END;
END;

(* search forward declarations with same operands types, link same types, test cardinality *)
PROCEDURE Contextualize(VAR sentinel: Objects);
VAR
  new, t1, t2, aop, fp, scope: Objects;

  FUNCTION eqptyp( t1, t2 : Structs) : BOOLEAN;
  BEGIN
    IF t1 = t2 THEN BEGIN
      RESULT:=TRUE;
      EXIT;
    END ELSE IF ( t1.comp = csDynArr ) AND ( t2.comp = csDynArr ) THEN BEGIN
      WHILE ( t1.comp = csDynArr ) AND ( t2.comp = csDynArr ) DO BEGIN
        t1 := t1.BaseTyp;
        t2 := t2.BaseTyp;
      END;
      RESULT:=t1 = t2;
      EXIT;
    END ELSE BEGIN
      RESULT:=FALSE;
      EXIT;
    END;
  END;
		
BEGIN
  new:=NewObj();
  t1:=sentinel.link;
  t2:=NIL;
  IF t1=NIL THEN
    err(143)	(* Cardinality Check *)
  ELSE BEGIN
    t2:=t1.link;
    IF (t2=NIL) AND NOT CheckCardinality(sentinel.name, 1) THEN
      err(143)
    ELSE IF (t2<>NIL) THEN BEGIN
      IF NOT CheckCardinality(sentinel.name, 2) OR (t2.link<>NIL) THEN
        err(143)
      ELSE IF IsExtern(t1) AND IsExtern(t2) THEN
        err(146);
    END ELSE IF IsExtern(t1) THEN
      err(146);
  END;
  aop:=sentinel.link2;
  scope:=sentinel.scope.left;
  WHILE (scope<>NIL)AND (scope.mnolev>=0) DO BEGIN
    WHILE aop<>NIL DO	BEGIN(* go along operator list *)
      fp:=aop.link;	
      IF eqptyp( t1.typ, fp.typ ) THEN BEGIN
        IF (t2<>NIL) AND (fp.link<>NIL) AND eqptyp( t2.typ, fp.link.typ ) THEN
          err(139)	(* multiply defined binary operator *)
        ELSE IF (t2=NIL) AND (fp.link=NIL) THEN
          err(139)	(* multiply defined unary operator *)
      END;
      aop:=aop.left
    END;
    scope:=scope.left;
    IF scope<>NIL THEN BEGIN
      FindInScope(sentinel.name, scope, aop);
      IF aop<>NIL THEN aop:=aop.link2;
    END
  END;
  CopyOp(new, sentinel);
  new.left:=sentinel.link2;
  sentinel.link2:=new;
  sentinel.prio:=127;
  sentinel:=new;
END;
	
PROCEDURE ODistance(typ, otyp: Structs; VAR distance: SHORTINT);
VAR
  t: Structs;
BEGIN
  distance:=MAX(_SHORTINTS);
  IF (typ.form=sfPointer) AND (otyp.comp IN [csStaticArr, csOpenArr, csSDynArr, csDynArr]) THEN typ:=typ.BaseTyp;
  IF typ=otyp THEN
    distance:=0
  ELSe IF typ=sinttyp THEN BEGIN
    IF otyp=inttyp THEN
      distance:=1
    ELSE IF otyp=linttyp THEN
      distance:=2
    ELSE IF otyp=realtyp THEN
      distance:=3
    ELSE IF otyp=lrltyp THEN
      distance:=4;
  END ELSE IF typ=inttyp THEN BEGIN
    IF otyp=linttyp THEN
      distance:=1
    ELSE IF otyp=realtyp THEN
      distance:=2
    ELSE IF otyp=lrltyp THEN
      distance:=3;
  END ELSE IF typ=linttyp THEN BEGIN
    IF otyp=realtyp THEN
      distance:=1
    ELSE IF otyp=lrltyp THEN
      distance:=2
  END ELSE IF typ=realtyp THEN BEGIN
    IF otyp=lrltyp THEN
      distance:=1
  END ELSE IF (typ.comp=otyp.comp) AND (typ.comp=csRecord) THEN BEGIN
    t:=typ;
    WHILE (t<>otyp) AND (t<>undftyp) AND (t<>NIL) DO t:=t.BaseTyp;
    IF t=otyp THEN distance:=typ.extlev-otyp.extlev;
  END ELSE IF (typ.form=sfString) AND (otyp.comp=csOpenArr) AND (otyp.BaseTyp.form=sfChar) THEN
    distance:=1
  ELSE IF (typ.comp IN [csStaticArr, csOpenArr, csSDynArr, csDynArr]) AND (otyp.comp=csOpenArr) THEN BEGIN
    WHILE otyp.comp=csOpenArr DO BEGIN
      otyp:=otyp.BaseTyp;
      typ:=typ.BaseTyp
    END;
    IF typ=otyp THEN
      distance:=1
    ELSE IF (typ.form=sfPointer) AND (otyp.form=sfPointer) THEN
      ODistance(typ.BaseTyp, otyp.BaseTyp, distance);
  END ELSE IF (typ.form=sfPointer)AND(otyp.form=sfPointer) THEN BEGIN
    typ:=typ.BaseTyp;
    otyp:=otyp.BaseTyp;
    IF (typ.comp = csRecord) AND (otyp.comp = csRecord) THEN BEGIN
      t:=typ;
      WHILE (t<>otyp) AND (t<>NIL) AND (t<>undftyp) DO t:= t.BaseTyp;
      IF t=otyp THEN distance:=typ.extlev-otyp.extlev;
    END;
  END;
END;
	
PROCEDURE QualResolve(VAR obj: Objects; VAR x, y: Nodes; VAR distance: SHORTINT; VAR wrn: BOOLEAN);
VAR
  op, yp: Objects;
  d1, d2: SHORTINT;

  FUNCTION CheckVarPar(act: Nodes; form: Objects): BOOLEAN;
  BEGIN
    RESULT:=(form.mode <> omVarPar) OR (act.clas < Nconst) OR (act.clas = Ncall)	(*allow VAR for temporary values*)
  END;
		
BEGIN
  op:=obj.link2;
  obj:=NIL;
  distance:=MAX(_SHORTINTS);
  WHILE op<>NIL DO BEGIN
    IF CheckVarPar(x, op.link) THEN BEGIN
      ODistance(x.typ, op.link.typ, d1);
      IF d1<>MAX(_SHORTINTS) THEN BEGIN
        yp:=op.link.link;
        IF y<>NIL THEN BEGIN
          IF yp<>NIL THEN BEGIN
            IF CheckVarPar(y, yp) THEN BEGIN
              ODistance(y.typ, yp.typ, d2);
              IF d2<MAX(_SHORTINTS) THEN BEGIN
                d1:=d1+d2;
                IF d1<distance THEN BEGIN
                  distance:=d1;
                  obj:=op;
                  wrn:=FALSE
                END ELSE IF d1=distance THEN
                  wrn:=TRUE;
              END
            END
          END
        END ELSE IF (yp=NIL) THEN BEGIN
          IF d1<distance THEN BEGIN
            distance:=d1;
            obj:=op;
            wrn:=FALSE
          END ELSE IF d1=distance THEN
            wrn:=TRUE
        END
      END
    END;
    op:=op.left
  END
END;
	
FUNCTION Resolve(VAR name: STRING; VAR x, y: Nodes): Objects;
VAR
  op, res, scope: Objects;
  i, d, distance: SHORTINT;
  wrn, warning: BOOLEAN;
BEGIN
  res:=NIL;
  distance:=MAX(_SHORTINTS);
  scope:=topScope;
  wrn:=FALSE;
  warning:=FALSE;
  WHILE scope<>NIL DO BEGIN
    FindInScope(name, scope, op);
    IF (op<>NIL) AND (op.scope<>NIL) THEN BEGIN
      scope:=op.scope.left.left;
      QualResolve(op, x, y, d, wrn);
      IF d<distance THEN BEGIN
        res:=op;
        distance:=d;
        warning:=wrn
      END ELSE IF d=distance THEN BEGIN
        IF d=0 THEN
          HALT(99)	(* BUG *)
        ELSE IF d<MAX(_SHORTINTS) THEN
          warning:=TRUE
      END
    END ELSE
      scope:=NIL
  END;
  i := 1;
  WHILE (i<nofmod) DO BEGIN
    FindInScope(name, Objects(modulesx[i]), op);
    IF op<>NIL THEN BEGIN
      QualResolve(op, x, y, d, wrn);	(* op=NIL => no op found; op#NIL => distance  *)
      IF d<distance THEN BEGIN
        res:=op;
        distance:=d;
        warning:=wrn
      END ELSE IF d=distance THEN BEGIN
        IF d=0 THEN
          HALT(99)	(* BUG *)
        ELSE IF d<MAX(_SHORTINTS) THEN
          warning:=TRUE
      END
    END;
    INC(i)
  END;
  IF warning THEN err(-310);	(* ambiguous operator *)
  RESULT:=res
END;

PROCEDURE OpenScope(level: SHORTINT; owner: Objects);
VAR
  head: Objects;
BEGIN
  head:=NewObj();
  head.mode := omHead;
  head.mnolev := level;
  head.link := owner;
  IF owner <> NIL THEN owner.scope := head;
  head.left := topScope;
  head.right:=NIL;
  head.scope:=NIL;
  topScope := head
END;

PROCEDURE CloseScope;
BEGIN 
  IF topScope <> NIL THEN topScope := topScope.left;
END;

PROCEDURE Init(VAR name: STRING);
BEGIN
  topScope := universe;
  OpenScope(0, NIL);
  nofmod := 1;
  SYSimported := FALSE;
  impSelf:=FALSE;
  sfpresent:=TRUE;
  OnewSF := (OPM.newsf IN OPM.options);
  OextSF := OnewSF OR (OPM.extsf IN OPM.options);
  modulesx[0]:=Modules(topScope);
  modulesx[0].publics:=NIL;
  modulesx[0].name:=name;
  topScope:=Objects(modulesx[0]);
END;

(* ----- Fingerprinting ----- *)

PROCEDURE FPrintTyp0(typ: Structs); FORWARD;

PROCEDURE FPrintName(VAR fp: LONGINT; VAR name: STRING);
VAR
  i: INTEGER;
  ch: CHAR;
BEGIN
  i:=1;
  IF name='' THEN name:=#0; //!!!!!
  REPEAT
    ch:=name[i];
    OPM.FPrint(fp, ORD(ch));
    INC(i)
  UNTIL ch=#0;
END;

PROCEDURE FPrintSign(VAR fp: LONGINT; result: Structs; par: Objects);
BEGIN 
  FPrintTyp0(result);
  OPM.FPrint(fp, result.fp);
  WHILE par<>NIL DO BEGIN
    OPM.FPrint(fp, par.mode); 
    IF par.typ <> NIL THEN BEGIN
      FPrintTyp0(par.typ);
      OPM.FPrint(fp, par.typ.fp)
    END;
    par:=par.link;
  END;
END;

PROCEDURE FPrintMeth(VAR pbfp, pvfp: LONGINT; fld: Objects);
VAR
  fp: LONGINT;
BEGIN
  IF fld<>NIL THEN BEGIN
    FPrintMeth(pbfp, pvfp, fld.left);
    IF (fld.mode=omTProc) AND (fld.vis<>internal) THEN BEGIN
      fp:=0;
      OPM.FPrint(fp, omTProc);
      FPrintName(fp, fld.name);
      FPrintSign(fp, fld.typ, fld.link);
      IF fld = fld.link.typ.strobj.link2 THEN OPM.FPrint (fp, -1);
      fld.fp:=fp;	(* mfix *)
      OPM.FPrint(fp, fld.adr DIV $10000);
      OPM.FPrint(pbfp, fp);
      OPM.FPrint(pvfp, fp);
    END;
    FPrintMeth(pbfp, pvfp, fld.right);
  END;
END;

PROCEDURE FPrintRecord(typ: Structs);
VAR
  fld: Objects;
  fp, pbfp, pvfp: LONGINT;
BEGIN 
  pvfp:=typ.fp;
  pbfp:=typ.fp;
  IF typ.BaseTyp<>NIL THEN BEGIN
    OPM.FPrint(pvfp, typ.BaseTyp.pvfp);
    OPM.FPrint(pbfp, typ.BaseTyp.pbfp);
  END; 
  IF typ.size<0 THEN typSize(typ, FALSE);
  fld:=typ.link;
  FPrintMeth(pbfp, pvfp, fld);
  WHILE (fld<>NIL) AND (fld.mode=omFld) DO BEGIN
    FPrintTyp(fld.typ);
    IF fld.vis<>internal THEN BEGIN
      fp:=0;
      OPM.FPrint(fp, fld.mode);
      FPrintName(fp, fld.name);
      OPM.FPrint(fp, fld.vis);
      IF fld.sysflag <> 0 THEN  OPM.FPrint(fp, fld.sysflag);
      OPM.FPrint(fp, fld.typ.fp);
      fld.fp:=fp;
      OPM.FPrint(pbfp, fld.typ.pbfp);
      OPM.FPrint(pbfp, fld.adr);
      OPM.FPrint(pvfp, fld.typ.pvfp);
      OPM.FPrint(pvfp, fld.adr);
      OPM.FPrint(pvfp, fp);
      OPM.FPrint(pbfp, fp);
      fld:=fld.link;
    END ELSE BEGIN
      fp := 0;
      IF fld.sysflag <> 0 THEN  OPM.FPrint(fp, fld.sysflag);
      fld.fp := fp;
      OPM.FPrint(pvfp, fld.fp);
      fld:=fld.link;
    END;
  END;
  OPM.FPrintSet (pbfp, typ.strobj.conval^.setval * [protectedObj, hasBody, activeObj] );
  typ.pbfp := pbfp;
  typ.pvfp := pvfp;	(* replace typ.pbfp with pbfp and typ.pvfp with pvfp *)
END;

PROCEDURE FPrintTyp0(typ: Structs);
(* calculate fingerprint without looking at record fields, private and public fingerprints *)
VAR
  fp, fp1, fp2: LONGINT;
  f, c: SHORTINT;
  btyp: Structs;
BEGIN 
  IF (typ <> NIL) AND (typ.fpdone>=0) THEN BEGIN(* not a built in type *)
    fp:=0;
    f:=typ.form;
    c:=typ.comp;
    OPM.FPrint(fp, f);
    OPM.FPrint(fp, c);
    fp1 := fp;
    IF typ.sysflag<>0 THEN OPM.FPrint(fp, typ.sysflag);
    IF typ.mno<>modNo THEN BEGIN
      FPrintName(fp, modulesx[typ.mno].name);
      FPrintName(fp, typ.strobj.name);
    END;
    fp2 := fp;
    btyp:=typ.BaseTyp;
    typ.fp:=fp;
    IF (c=csRecord) AND (btyp<>NIL) OR (f=sfPointer) THEN BEGIN
      FPrintTyp0(btyp);
      OPM.FPrint(typ.fp, btyp.fp);
    END ELSE IF c IN [csStaticArr, csSDynArr, csDynArr, csOpenArr] THEN BEGIN
      FPrintTyp0(btyp);
      OPM.FPrint(typ.fp, btyp.fp);
      IF c=csStaticArr THEN OPM.FPrint(typ.fp, typ.n);
      typ.pbfp:=typ.fp;
      typ.pvfp:=typ.fp;
    END ELSE IF f=sfProcTyp THEN BEGIN
      FPrintSign(typ.fp, btyp, typ.link);
      typ.pbfp:=typ.fp;
      typ.pvfp:=typ.fp;
    END ELSE IF (f=sfPointer) THEN
      OPM.FPrint (typ.fp, 1);

    IF TraceFP THEN BEGIN
      OPM.LogWLn;
      OPM.LogWStr('FPTyp0 - ');
      OPM.LogWHex(fp1);
      OPM.LogWHex(fp2);
      OPM.LogWHex(typ.fp);
      IF typ.strobj <> NIL THEN BEGIN
        OPM.LogWStr(' - ');
        OPM.LogWStr(typ.strobj.name)
      END;
    END;

  END;
END;

PROCEDURE FPrintTyp(typ: Structs);
(* fpdone  0: not done yet  >0: done for module fpdone-1  =-1: built in type *)
BEGIN 
  IF (typ <> NIL) AND (typ.fpdone<>modNo+1) AND (typ.fpdone>=0) THEN BEGIN
    FPrintTyp0(typ);
    IF (typ.comp <> csRecord) THEN typ.fpdone:=modNo+1;
    IF typ.BaseTyp<>NIL THEN FPrintTyp(typ.BaseTyp);
    IF (typ.comp=csRecord) THEN FPrintRecord(typ);
    typ.fpdone:=modNo+1;

    IF TraceFP THEN BEGIN
      OPM.LogWLn;
      OPM.LogWStr('FPTyp  - ');
      OPM.LogWHex(typ.fp);
      OPM.LogWHex(typ.pbfp);
      OPM.LogWHex(typ.pvfp);
      IF typ.strobj <> NIL THEN BEGIN
        OPM.LogWStr(' - ');
        OPM.LogWStr(typ.strobj.name)
      END;
    END;
    
  END;
END;

PROCEDURE FPrintObj(obj: Objects);
VAR
  fp, fp1: LONGINT;
  rval: REAL;
  f, m: INTEGER;
  ext: STRING;
  n: Nodes;
BEGIN 
  fp:=0; 
  OPM.FPrint(fp, obj.mode);
  FPrintName(fp, obj.name);
  OPM.FPrint(fp, obj.vis);
  IF TraceFP THEN fp1 := fp;
  IF obj.mode=omCon THEN BEGIN
    f:=obj.typ.form;
    OPM.FPrint(fp, f);
     OPM.FPrint(fp, obj.typ.comp);
    CASE f OF
      sfBool, sfChar, sfSInt, sfInt, sfLInt:
                OPM.FPrint(fp, obj.conval^.intval);
      sfSet   : OPM.FPrintSet(fp, obj.conval^.setval);
      sfReal  :
                BEGIN
                  rval:=obj.conval^.realval;
                  OPM.FPrintReal(fp, rval);
                END;
      sfLReal : OPM.FPrintLReal(fp, obj.conval^.realval);
      sfString: FPrintName(fp, obj.conval^.ext);
      sfNilTyp: ;
    END
  END ELSE IF obj.mode=omVar THEN BEGIN
    FPrintTyp(obj.typ);
    OPM.FPrint(fp, obj.typ.fp);
  END ELSE IF obj.mode=omXProc THEN  BEGIN
    FPrintSign(fp, obj.typ, obj.link);
    IF  obj.sysflag <> 0  THEN  OPM.FPrint(fp, obj.sysflag);
  END ELSE IF obj.mode=omCProc THEN BEGIN
    FPrintSign(fp, obj.typ, obj.link);
    n := obj.code.left;
    WHILE n <> NIL DO BEGIN
      ext := n.conval^.ext;
      m := ORD(ext[1]);
      f := 1;
      OPM.FPrint(fp, m);
      WHILE  f<=m DO BEGIN
        OPM.FPrint(fp, ORD(ext[f]));
        INC(f)
      END;
      n := n.link
    END;
  END ELSE IF obj.mode=omTyp THEN BEGIN
    FPrintTyp(obj.typ);
    OPM.FPrint(fp, obj.typ.fp);
  END;
  obj.fp:=fp;

  IF TraceFP THEN BEGIN
    OPM.LogWLn;
    OPM.LogWStr('FPObj  - ');
    OPM.LogWHex(fp1);
    OPM.LogWHex(fp);
    OPM.LogWStr(' - ');
    OPM.LogWStr(obj.name)
  END;

END;
		
PROCEDURE FPrintErr(obj: Objects);
VAR
  errNo: INTEGER;
BEGIN 
  IF expGlobal	THEN BEGIN
    IF	    obj.history=removed	  THEN	errNo:=450
    ELSE IF	obj.history=inserted	THEN	errNo:=451
    ELSE IF	obj.history=modified	THEN	errNo:=452
    ELSE    EXIT;
    OPM.errName:=obj.name;
    IF errNo=451 THEN BEGIN(* inserted *)
      IF NOT OextSF THEN err(errNo);
      symExtended:=TRUE;
    END ELSE BEGIN
      IF NOT OnewSF THEN err(errNo);
      symNew:=TRUE;
    END;
    IF errNo=450 THEN obj.vis:=internal;
  END
END;

(* Import *)
FUNCTION MatchOp(op, list: Objects): Objects;
BEGIN
  FPrintObj (op);
  list := list.link2;
  WHILE (list <> NIL) AND (list.old=NIL) DO BEGIN		(* (list.old#NIL) only for imported elements *)
    IF list.fp = 0 THEN FPrintObj (list);
    IF op.fp = list.fp THEN BEGIN
      RESULT:=list;
      EXIT;
    END;
    list := list.left;
  END;
  RESULT:=NIL
END;

PROCEDURE InsertImport(obj: Objects; root: Objects);
VAR
  ob0, ob1: Objects;
  left: BOOLEAN;	(* old in obj.scope *)
BEGIN
  ob0:=root;
  ob1:=ob0.right;
  left:=FALSE;
  REPEAT
    IF	ob1<>NIL	THEN BEGIN
      IF	obj.name < ob1.name	THEN BEGIN
        ob0:=ob1;
        ob1:=ob1.left;
        left:=TRUE
      END ELSE IF	obj.name > ob1.name	THEN BEGIN
        ob0:=ob1;
        ob1:=ob1.right;
        left:=FALSE
      END ELSE IF	obj.name=''	THEN BEGIN
        obj.scope:=NIL;
        EXIT;
      END ELSE BEGIN
        obj.old:=ob1;			(* operators, link to the sentinel. Search not possible because parm aren't read yet! *)
        IF (ob1.prio = 127) AND (root.mnolev <> 0) THEN	BEGIN(* append to list, if really imported; 0 is self used for sf check *)
          obj.right := NIL;
          obj.left := ob1.link2;
          ob1.link2 := obj;
          obj.mnolev := root.mnolev
        END;
        BREAK;
      END;
    END ELSE BEGIN
      IF obj.prio=126 THEN BEGIN	(*Insert first a sentinel *)
        obj.left := NIL;
        ob1 := obj;
        obj := NewObj();
        CopyOp (obj, ob1);
        obj.prio := 127;
        obj.link2 := ob1;
        ob1.old := NIL;
        ob1.mnolev := root.mnolev
      END;
      IF	left	THEN	ob0.left:=obj	ELSE ob0.right:=obj;
      obj.left:=NIL;
      obj.right:=NIL;
      obj.old:=NIL;
      obj.mnolev:=root.mnolev; 
      EXIT;
    END;
  UNTIL FALSE;
END;

FUNCTION CompOldTyp(typ, oldtyp: Structs): SHORTINT;
BEGIN
  IF (typ.form=sfComp) AND (typ.comp<>csRecord) OR (typ.form=sfPointer) THEN BEGIN
    RESULT:=CompOldTyp(typ.BaseTyp, oldtyp.BaseTyp);
    EXIT;
  END ELSE IF (typ.form=sfComp) AND (typ.comp=csRecord) THEN BEGIN
    IF (typ.pvfp<>oldtyp.pvfp) OR (typ.pbfp<>oldtyp.pbfp) THEN BEGIN
      RESULT:=modified;
      EXIT;
    END ELSE BEGIN
      RESULT:=same;
      EXIT;
    END
  END ELSE
    RESULT:=same;
END;

PROCEDURE CompOldSym(obj: Objects);
VAR
  old: Objects;
BEGIN
  WHILE obj<>NIL DO BEGIN
    old:=obj.old;
    IF (old<>NIL) AND (old.prio = 127) THEN BEGIN
      old := MatchOp (obj, old);
      obj.old := old
    END;
    IF old<>NIL THEN BEGIN
      IF obj.prio<>126 THEN BEGIN
        FPrintObj(obj);
        FPrintObj(old)
      END;
      IF obj.fp<>old.fp THEN BEGIN
        IF	(obj.vis<>old.vis) AND (old.vis=internal)	THEN BEGIN
          obj.history:=removed;
          FPrintErr(obj)
        END ELSE
          old.history:=modified;
      END ELSE IF (obj.mode=omTyp) OR (obj.typ.form=sfComp)
      AND (obj.typ.comp=csRecord) AND (obj.typ.strobj.name='') THEN
        old.history:=CompOldTyp(obj.typ, old.typ)
      ELSE
        old.history:=same;
    END ELSE
      obj.history:=removed;
    obj:=obj.nxtobj;
  END;
END;

(* ----- read sym file ----- *)

PROCEDURE Imp(VAR impName, modName: STRING; VAR M: Modules);
VAR
  i: INTEGER;
  tag: LONGINT;
  done: BOOLEAN;
  mode: SHORTINT;
  obj, last: Objects;
  tdum: Structs;
  Anew, operator: BOOLEAN;
  F : TMemoryStream;

  PROCEDURE InStruct(VAR typ: Structs; par: BOOLEAN); FORWARD;

  PROCEDURE GetImports;
  VAR
    name: STRING;
    TM: Modules;
  BEGIN
    OPM.ReadString(F, name);
    WHILE	name<>'' DO	BEGIN
      Imp(name, modName, TM);
      M.import[M.nofimp]:=TM;
      INC(M.nofimp);
      IF M.nofimp>=LENGTH(M.import) THEN DoubleModArr(M.import);
      M.nofreimp:=0;
      OPM.ReadString(F, name)
    END;
  END;

  PROCEDURE InParList(VAR first: Objects);
  VAR
    last, par: Objects;
  BEGIN
    first:=NIL;
    last:=NIL;
    OPM.ReadNum(F, tag);
    WHILE	tag<>SFend	DO BEGIN
      par:=Objects.Create;
      IF	last=NIL THEN
        first:=par
      ELSE
        last.link:=par;
      last:=par;
      IF tag=SFvar THEN	BEGIN
        par.mode:=omVarPar;
        OPM.ReadNum(F, tag);
      END ELSE
        par.mode:=omVar;
      InStruct(par.typ, TRUE);
      OPM.ReadString(F, par.name);
      OPM.ReadNum(F, tag)
    END;
  END;
		
  PROCEDURE SetTypFlags(typ: Structs);
  BEGIN
    IF (typ.extlev = -1) OR (typ.n < 0) THEN BEGIN
      IF typ.BaseTyp <> NIL THEN BEGIN
        SetTypFlags(typ.BaseTyp);
        typ.extlev := typ.BaseTyp.extlev + 1; 
        typ.n := typ.BaseTyp.n;
        typ.strobj.conval^.setval := typ.strobj.conval^.setval + (typ.BaseTyp.strobj.conval^.setval * [protectedObj]);
      END ELSE BEGIN
        typ.extlev := 0;
        typ.n := 0;
        typ.strobj.scope.left := topScope;
      END;
    END
  END;
		
  PROCEDURE InRecord(typ: Structs);
  VAR
    scope, last, fld: Objects;
    flags: TSET;
    conval: Consts;
  BEGIN
    scope:=Objects.Create;
    scope.mode:=omHead;
    scope.mnolev:=-typ.mno;
    last:=NIL;
    conval := NewConst();
    typ.strobj.conval := conval;
    OPM.ReadNum(F,LONGINT(flags));
    IF 0 IN flags THEN INCL(conval.setval, protectedObj);
    IF 1 IN flags THEN INCL(conval.setval, activeObj);
    IF 2 IN flags THEN INCL(conval.setval, safe);
    F.Read (typ.strobj.prio,1);
    OPM.ReadNum(F, tag);
    WHILE	tag<SFtproc	DO BEGIN
      fld:=Objects.Create;
      IF	last<>NIL	THEN last.link:=fld;
      last:=fld;
      IF tag=SFobjflag THEN BEGIN
        F.Read(fld.sysflag,1);
        OPM.ReadNum(F, tag);
      END;
      IF tag=SFreadonly THEN BEGIN
        OPM.ReadNum(F, tag);
        fld.vis:=externalR
      END ELSE
        fld.vis:=external;
      fld.mode:=omFld;
      InStruct(fld.typ, FALSE);
      OPM.ReadString(F, fld.name);
      IF	fld.name=''	THEN fld.vis:=internal;
      InsertImport(fld, scope);
      OPM.ReadNum(F, tag);
    END;
    IF	tag=SFtproc	THEN BEGIN
      OPM.ReadNum(F, tag);
      WHILE	tag<>SFend DO	BEGIN
        fld:=Objects.Create;
        fld.mode:=omTProc;
        fld.vis:=external;
        fld.conval:=NewConst();
        fld.linkadr := OPM.LANotAlloc;	(* mfix *)
        fld.conval^.setval:=[hasBody];	(* mfix *)
        InStruct(fld.typ, FALSE);
        OPM.ReadString(F, fld.name);
        IF fld.name = '' THEN BEGIN
          fld.vis:=internal;
          OPM.ReadString(F, fld.name);
        END;
        InParList(fld.link);
        IF fld.name = ObjBody THEN BEGIN
          typ.strobj.link := fld.link;
          fld := typ.strobj;
          INCL (conval.setval, hasBody)
        END ELSE BEGIN
          IF fld.name[1] = '&' THEN BEGIN
            fld.name:=copy(fld.name,2,Length(fld.name)-1);
            typ.strobj.link2 := fld
          END;
          InsertImport(fld, scope);
        END;
        OPM.ReadNum(F, tag)
      END;
    END;
    ASSERT( NOT (activeObj IN conval.setval) OR (hasBody IN conval.setval));
    typ.strobj.scope := scope;
    typ.link:=scope.right
  END;
		
  PROCEDURE InStruct(VAR typ: Structs; par: BOOLEAN);
  VAR
    typtag, typadr: LONGINT;
    vis: SHORTINT;
    tobj: Objects;
    btyp: Structs;
    typname: STRING;
    Amod: Modules;
    i: INTEGER;
  BEGIN
    IF	tag <= 0	THEN BEGIN
      DEC(tag);
      ASSERT(tag>-LENGTH(M.struct));
      typ:=M.struct[-tag]
    END ELSE IF tag <= SFlastStruct THEN
      typ:=predefStruct[tag]
    ELSE IF tag <= SFmodOther THEN BEGIN
      IF tag = SFmodOther THEN
        OPM.ReadNum(F, tag)
      ELSE
        tag:=tag-SFmod1;
      Amod:=M.import[tag];
      OPM.ReadString(F, typname);
      IF typname<>'' THEN BEGIN
        i:=1;
        WHILE (i<Amod.nofstr) AND (Amod.struct[i].strobj.name<>typname) DO INC(i);
        IF i<Amod.nofstr THEN
          typ:=Amod.struct[i]
        ELSE BEGIN
          typ:=niltyp;
          IF NOT impSelf THEN err(150);
        END;
        INC(Amod.nofreimp);
        IF Amod.nofreimp>=LENGTH(Amod.reimp) THEN DoubleStructArr(Amod.reimp);
        Amod.reimp[Amod.nofreimp]:=typ;
      END ELSE BEGIN
        OPM.ReadNum(F, typadr);
        INC(typadr);
        ASSERT(typadr < LENGTH(Amod.reimp));
        typ:=Amod.reimp[typadr];
      END
    END ELSE BEGIN
      typ:=Structs.Create;
      M.struct[M.nofstr]:=typ;
      typ.tdadr:=OPM.TDAdrUndef;
      typ.offset:=OPM.TDAdrUndef;
      typ.sref:=-M.nofstr;
      INC(M.nofstr);
      IF M.nofstr>=LENGTH(M.struct) THEN DoubleStructArr(M.struct);
      IF	tag=SFinvisible	THEN BEGIN
        vis:=internal;
        OPM.ReadNum(F, tag)
      END ELSE
        vis:=external;
      IF	tag=SFsysflag	THEN BEGIN
        OPM.ReadNum(F, tag);
        typ.sysflag:=tag;
        OPM.ReadNum(F, tag);
      END;
      typ.form:=strucForm[tag];
      typ.comp:=strucComp[tag];
      typ.mno:=-M.mnolev;
      typ.size:=-1;
      typtag:=tag;
      OPM.ReadNum(F, tag);
      typ.extlev := -1;
      InStruct(typ.BaseTyp, par);
      btyp := typ.BaseTyp;
      IF (typ.comp=csRecord) AND ((btyp = notyp) OR (btyp = niltyp)) THEN	(*PaCo exports the rec.btyp as notyp*)
        typ.BaseTyp := NIL
      ELSE IF (typ.comp=csRecord) AND (btyp<>NIL) AND (btyp.form=sfPointer) THEN
        typ.BaseTyp := btyp.BaseTyp
      ELSE IF (typ.form=sfPointer) AND (btyp.comp=csRecord) AND (btyp.strobj.name='') THEN
        btyp.ptr := typ;
      tobj:=Objects.Create;
      tobj.mode:=omTyp;
      tobj.nxtobj:=last;
      last:=tobj;
      tobj.typ:=typ;
      OPM.ReadString(F, tobj.name);
      typ.strobj := tobj;
      IF	tobj.name<>''	THEN BEGIN
        tobj.vis:=vis;
        tobj.typ:=typ;
        InsertImport(tobj,Objects(M));
      END;
      CASE	typtag	OF
        SFtypDynArr, SFtypOpenArr:
                          IF btyp.comp IN [csDynArr, csOpenArr] THEN
                            typ.n := btyp.n + 1
                          ELSE
                            typ.n := 0;
        SFtypArray:       OPM.ReadNum(F, typ.n);
        SFtypPointer: ;
        SFtypRecord:
                          BEGIN
                            InRecord(typ);
                            typ.n := -1;
                          END;
        SFtypProcTyp:	    InParList(typ.link);
      END;
      IF impSelf AND (tobj.name<>'') AND (tobj.vis<>internal) THEN
        typ.sref:=0;
    END
  END;

  PROCEDURE InObj;
  BEGIN
    obj:=Objects.Create;
    obj.mode:=mode;
    obj.nxtobj:=last;
    last:=obj;
    IF (tag = SFobjflag) THEN BEGIN
      F.Read(obj.sysflag,1);
      OPM.ReadNum(F, tag)
    END;
    IF tag=SFreadonly THEN BEGIN
      OPM.ReadNum(F, tag);
      obj.vis:=externalR;
    END ELSE
      obj.vis:=external;
    InStruct(obj.typ, FALSE);
    OPM.ReadString(F, obj.name);
    IF operator THEN obj.prio := 126;
    InsertImport(obj, Objects(M));
  END;

  PROCEDURE InCProc;
  VAR
    n, last: Nodes;
    ext: STRING;
    ch: CHAR;
    i, len: LONGINT;
  BEGIN
    obj.code:=Nodes.Create;
    obj.code.clas := 29; (*Nassembler*)
    obj.code.conval := NewConst();	(*OPV takes the code position from it! *)
    obj.code.obj := obj;
    F.Read(ch,1);
    last:=NIL;
    REPEAT
      n:=Nodes.Create;
      n.conval := NewConst();
      ext := NewExt();
      n.conval^.ext := ext;
      IF  obj.code.left = NIL THEN
        obj.code.left := n
      ELSE
        last.link := n;
      last := n;
      len := ORD(ch);
      ext[1] := ch;
      i := 2;
      WHILE i <= len DO BEGIN
        F.Read(ext[i],1);
        INC(i)
      END;
      F.Read(ch,1)
    UNTIL ch = #0;
  END;

  PROCEDURE InConst;
  VAR
    conval: Consts;
    r: REAL;
  BEGIN
    NEW(conval);
    obj.conval:=conval;
    CASE	tag	OF
      SFtypBool, SFtypChar,
      SFtypSInt..SFtypLInt:	OPM.ReadNum(F, conval.intval);
      SFtypSet  :	  OPM.ReadNum(F,LONGINT(conval.setval));
      SFtypReal :
                    BEGIN
                      F.Read(r,RealSize);
                      conval.realval := r;
                      conval.intval := OPM.ConstNotAlloc
                    END;
      SFtypLReal:
                    BEGIN
                      F.Read(conval.realval,LRealSize);
                      conval.intval := OPM.ConstNotAlloc;
                    END;
      SFtypString:
                    BEGIN
                      OPM.ReadString(F, conval.ext);
                      conval.intval:=OPM.ConstNotAlloc;
                      conval.intval2:=LENGTH(conval.ext)+1;
                    END;
      SFtypNilTyp: ;
    END
  END;

BEGIN
  i:=0;

  WHILE	(i < nofmod) AND (impName<>modulesx[i].name) DO INC(i);

  IF	i < nofmod	THEN BEGIN
    M:=modulesx[i];
    Anew:=FALSE;
  END ELSE BEGIN
    M:=NewMod();
    M.name:=impName;
    M.mnolev:=-nofmod;
    modulesx[nofmod]:=M;
    INC(nofmod);
    IF nofmod>=LENGTH(modulesx) THEN DoubleModArr(modulesx);
    Anew:=TRUE; 
  END;
  M.nofreimp:=0;

  if i=0 then M.publics:=NIL; //!!!***

  IF Anew	OR	impSelf AND (i=0)	THEN BEGIN
    M.nofimp:=0;
    M.struct[0]:=NIL;  ///!!!***
    M.nofstr:=1;
    operator:=FALSE;
    F := TMemoryStream.Create;
    OPM.OpenSym(F, impName, impSelf, done);
    IF	done	THEN BEGIN
      GetImports;
      IF OPM.noerr	THEN BEGIN
        i:=0;

        WHILE i<nofmod DO BEGIN
          modulesx[i].nofreimp:=0;
          INC(i)
        END;

        last:=NIL;
        OPM.ReadNum(F, tag);

        IF	tag=SFconst	THEN BEGIN
          mode:=omCon;
          OPM.ReadNum(F, tag);
          WHILE	tag < SFvar	DO BEGIN
            InObj;
            InConst;
            OPM.ReadNum(F, tag)
          END;
        END;

        IF	tag=SFvar	THEN BEGIN
          mode:=omVar;
          OPM.ReadNum(F, tag);
          WHILE	tag < SFxproc	DO BEGIN
            InObj;
            OPM.ReadNum(F, tag);
          END;
        END;

        IF	tag=SFxproc	THEN BEGIN
          mode:=omXProc;
          OPM.ReadNum(F, tag);
          WHILE	tag < SFoperator DO BEGIN
            InObj;
            InParList(obj.link);
            OPM.ReadNum(F, tag);
            obj.conval:=NewConst();
            obj.conval^.setval:=[];
          END;
        END;

        IF	tag=SFoperator THEN BEGIN
          mode:=omXProc;
          operator:=TRUE;
          OPM.ReadNum(F, tag);
          WHILE	tag < SFcproc DO BEGIN
            InObj;
            InParList(obj.link);
            obj.conval:=NewConst();
            obj.conval^.setval:=[];
            OPM.ReadNum(F, tag)
          END;
          operator:=FALSE;
        END;

        IF	tag=SFcproc	THEN BEGIN
          mode:=omCProc;
          OPM.ReadNum(F, tag);
          WHILE	tag < SFalias	DO BEGIN
            InObj;
            InParList(obj.link);
            obj.conval:=NewConst();
            obj.conval^.setval:=[hasBody, asmProc];
            InCProc;
            OPM.ReadNum(F, tag)
          END;
        END;

        IF	tag=SFalias	THEN BEGIN
          OPM.ReadNum(F, tag);
          WHILE	tag < SFtyp	DO BEGIN
            obj:=Objects.Create;
            obj.vis:=external;
            obj.mode:=omTyp;
            InStruct(obj.typ, FALSE);
            OPM.ReadString(F, obj.name);
            IF obj.typ.strobj.vis = internal THEN
              INCL(obj.typ.strobj.flag, typeVisible);
            InsertImport(obj, Objects(M));
            CompOldSym(obj);
            OPM.ReadNum(F, tag);
          END;
        END;

        IF	tag=SFtyp	THEN BEGIN
          OPM.ReadNum(F, tag);
          WHILE	tag < SFend	DO BEGIN
            InStruct(tdum, FALSE);
            OPM.ReadNum(F, tag);
          END;
        END;

        M.publics:=last;
        
        WHILE last <> NIL DO BEGIN
          IF (last.mode = omTyp) AND (last.typ.form = sfComp)
          AND (last.typ.comp = csRecord) THEN SetTypFlags(last.typ);
          last := last.nxtobj
        END;
        F.Free;
      END;
    END ELSE BEGIN
      IF impSelf THEN BEGIN
        OnewSF:=TRUE;
        OextSF:=TRUE;
        sfpresent:=FALSE
      END ELSE
        err(152);
    END;
  END;
END;

PROCEDURE Import(VAR aliasName, impName, selfName: STRING);
VAR
  ali: Objects;
  M: Modules;
BEGIN
  Insert(aliasName, ali);
  ali.mode:=omMod;
  ali.typ:=notyp;
  IF impName='SYSTEM' THEN BEGIN
    SYSimported:=TRUE;
    ali.mnolev:=0;
    ali.scope:=syslink;
    ali.adr:=0
  END ELSE BEGIN
    IF (impName=selfName) AND (aliasName<>'@self') THEN BEGIN
      M:=NewMod();
      err(49);
    END;
    impSelf := (impName=modulesx[0].name);
    Imp(impName, selfName, M);
    M.directImp:=TRUE;
    ali.scope:=M.right;
    ali.mnolev:=M.mnolev
  END;
END;

(* Export *)

PROCEDURE OutMod(F: TMemoryStream; amod: Modules);
BEGIN
  IF amod.mode=0	THEN BEGIN
    OPM.SymWMod(F,Amod.name);
    INC(nofemod);
    Amod.mode:=nofemod
  END;
END;

PROCEDURE OutStruct(F: TMemoryStream; typ: Structs); FORWARD;

PROCEDURE Enumerate(obj: Objects);
VAR
  p: Objects;
BEGIN
  IF	obj<>NIL	THEN BEGIN
    IF obj.prio=127 THEN BEGIN
      p := obj.link2;
      WHILE p <> NIL DO BEGIN
        p.sibling:=exp[omOperator];
        exp[omOperator]:=p;
        p:=p.left
      END;
      Enumerate(obj.left);
      Enumerate(obj.right)
    END ELSE BEGIN
      Enumerate(obj.left);
      IF	(obj.vis > internal)=export	THEN BEGIN
        IF	expGlobal AND (obj.history=removed)	THEN BEGIN
          FPrintErr(obj);
          obj.mode:=sfUndef;
        END ELSE BEGIN
          IF	(obj.mode<>omTyp) OR (obj.typ.strobj<>obj) THEN	FPrintErr(obj);
          IF	(obj.mode=omTyp)AND(obj.typ.strobj<>obj) THEN BEGIN
            obj.sibling:=exp[omAlias];
            exp[omAlias]:=obj;
          END ELSE IF	(obj.mode<>omVar) OR (NOT obj.par) THEN BEGIN
            obj.sibling:=exp[obj.mode];
            exp[obj.mode]:=obj;
          END;
        END;
      END;
      Enumerate(obj.right);
    END;
  END;
END;

PROCEDURE OutCProc(F: TMemoryStream; n: Nodes);
VAR
  ext: STRING;
  i, len: LONGINT;
BEGIN
  REPEAT
    ext := n.conval^.ext;
    len := ORD(ext[1]);
    i := 1;
    WHILE i <= len DO BEGIN
      OPM.SymW(F,ext[i]);
      INC(i)
    END;
    n := n.link
  UNTIL n = NIL;
  OPM.SymW(F,#0)
END;

PROCEDURE OutParList(F: TMemoryStream; par: Objects);
BEGIN	
  WHILE	par<>NIL	DO BEGIN
    IF	par.mode=omVarPar	THEN OPM.SymW(F,CHR(SFvar));
    OutStruct(F,par.typ);
    OPM.SymWString(F,par.name);
    par.par:=TRUE;
    par.nxtobj:=par.link ;
    par:=par.link
  END;
  OPM.SymWNum(F,SFend);
END;

PROCEDURE OutFld(F: TMemoryStream; fld: Objects);
BEGIN
  WHILE	fld<>NIL	DO BEGIN
    IF  fld.sysflag <> 0 THEN BEGIN
      OPM.SymW(F,CHR(SFobjflag));
      OPM.SymW(F,CHR(fld.sysflag))
    END;
    IF	fld.vis=externalR	THEN OPM.SymW(F,CHR(SFreadonly));
    OutStruct(F,fld.typ);
    IF	fld.vis>internal THEN
      OPM.SymWString(F,fld.name)
    ELSE
      OPM.SymW(F,#0);
    fld:=fld.link
  END;
END;

PROCEDURE OutRecord(F: TMemoryStream; typ: Structs);
VAR
  count: LONGINT;
  flag : TSET;

  PROCEDURE TraverseBody (F: TMemoryStream; fld: Objects);
  VAR
    str: STRING;
  BEGIN
    IF (fld <> NIL) AND (hasBody IN fld.conval^.setval) THEN BEGIN
      OPM.SymW(F,CHR(SFtproc));	(* this is the first method!! *)
      str:=ObjBody;
      INC (count);
      OutStruct (F,notyp);
      OPM.SymWString(F,str);
      OutParList(F,fld.link);
    END
  END;

  PROCEDURE TraverseT(F: TMemoryStream; fld: Objects);
  BEGIN
    IF	fld<>NIL THEN	BEGIN
      TraverseT(F,fld.left);
      IF fld.mode=omTProc THEN BEGIN
        IF	count=0	THEN OPM.SymW(F,CHR(SFtproc));
        INC(count);
        OutStruct(F,fld.typ);
        IF	fld.vis = internal THEN	OPM.SymW(F,#0);
        IF fld = typ.strobj.link2 THEN OPM.SymW (F,'&');
        OPM.SymWString(F,fld.name);
        OutParList(F,fld.link);
      END;
      TraverseT(F,fld.right)
    END;
  END;

BEGIN
  flag:=[];
  IF protectedObj IN typ.strobj.conval^.setval THEN INCL(flag, 0);
  IF activeObj IN typ.strobj.conval^.setval THEN INCL(flag, 1);
  IF safe IN typ.strobj.conval^.setval THEN INCL(flag, 2);
  OPM.SymWSet(F,flag);
  OPM.SymWCh(F,CHR(typ.strobj.prio));
  IF	(typ.link<>NIL) AND (typ.link.mode=omFld)	THEN OutFld(F,typ.link);
  count:=0;
  TraverseBody(F,typ.strobj);
  TraverseT(F,typ.link);
  OPM.SymWNum(F,SFend);
END;

PROCEDURE OutStruct(F: TMemoryStream; typ: Structs);
VAR
  tag: SHORTINT;
  Amod: Modules;
  tobj: Objects;
BEGIN
  IF	typ=NIL	THEN
    OPM.SymW(F,#0)
  ELSE IF	typ.mno<>0 THEN	BEGIN
    Amod:=modulesx[typ.mno];
    OutMod(ModF,Amod);
    IF Amod.nofstr>0 THEN Amod.nofstr:=0;
    IF Amod.mode>31 THEN BEGIN
      OPM.SymW(F,CHR(SFmodOther));
      OPM.SymWNum(F,Amod.mode-1)
    END ELSE
      OPM.SymW(F,CHR(SFmod1-1+Amod.mode));
    IF typ.sref<0 THEN BEGIN
      DEC(Amod.nofstr);
      typ.sref:=-Amod.nofstr;
      OPM.SymWString(F,typ.strobj.name);
    END ELSE BEGIN
      OPM.SymW(F,#0);
      OPM.SymWNum(F,typ.sref-1);
    END; 	(*!!!sref > 0*)
  END ELSE IF	typ.sref>0 THEN
    OPM.SymWNum(F,typ.sref)	(*!!!sref < 0*)
  ELSE IF	typ.sref<>0 THEN
    OPM.SymWNum(F,typ.sref+1)	(*!!!sref < 0*)
  ELSE BEGIN
    DEC(nofstruc);
    typ.sref:=nofstruc;
    tag:=strucFormSF[typ.form]+strucCompSF[typ.comp];
    IF	export AND(typ.strobj<>NIL) AND (typ.strobj.vis=internal) THEN
      OPM.SymW(F,CHR(SFinvisible));
    IF	typ.sysflag<>0	THEN BEGIN
      OPM.SymW(F,CHR(SFsysflag));
      OPM.SymW(F,CHR(typ.sysflag))
    END;
    OPM.SymW(F,CHR(tag));
    IF (typ.comp=csRecord) AND (typ.BaseTyp<>NIL) AND (typ.BaseTyp.ptr<>NIL) THEN
      OutStruct(F,typ.BaseTyp.ptr)
    ELSE IF (typ.comp=csRecord) AND (typ.BaseTyp=NIL) THEN
      OutStruct(F,notyp)
    ELSE
      OutStruct(F,typ.BaseTyp);
    tobj:=Objects.Create;
    tobj.mode:=omTyp;
    tobj.nxtobj:=objectsx;
    objectsx:=tobj;
    tobj.typ:=typ;
    IF	(typ.strobj=NIL) OR (typ.strobj.name='') THEN
      OPM.SymW(F,#0)
    ELSE BEGIN
      FPrintErr(typ.strobj);
      OPM.SymWString(F,typ.strobj.name);
      tobj.name:=typ.strobj.name;
    END;
    CASE	tag	OF
      SFtypDynArr, SFtypOpenArr: ;
      SFtypArray  : OPM.SymWNum(F,typ.n);
      SFtypPointer: ;
      SFtypRecord :	OutRecord(F,typ);
      SFtypProcTyp:	OutParList(F,typ.link);
    END
  END
END;

PROCEDURE OutConst(F: TMemoryStream; form: SHORTINT; conval: Consts);
BEGIN
  CASE	form	OF
    sfBool, sfChar,
    sfSInt..sfLInt:	OPM.SymWNum(F,conval.intval);
    sfSet         :	OPM.SymWSet(F,conval.setval);
    sfReal        :	OPM.SymWReal(F,conval.realval);
    sfLReal       :	OPM.SymWLReal(F,conval.realval);
    sfString      :	OPM.SymWString(F,conval.ext);
    sfNilTyp      : ;
  END;
END;

PROCEDURE OutObj(F: TMemoryStream; obj: Objects);
BEGIN
  obj.nxtobj:=objectsx;
  objectsx:=obj;
  OutStruct(F,obj.typ);
  IF obj = topScope.link.link2 THEN OPM.SymW (F,'&');
  OPM.SymWString(F,obj.name)
END;

PROCEDURE OutScope(F: TMemoryStream; scope: Objects; public: BOOLEAN);
VAR
  obj: Objects;
  first: BOOLEAN;
BEGIN
  export          := public;
  exp[omCon]      := NIL;
  exp[omVar]      := NIL;
  exp[omLProc]    := NIL;
  exp[omXProc]    := NIL;
  exp[omAlias]    := NIL;
  exp[omTyp]      := NIL;
  exp[omOperator] := NIL;
  Enumerate(scope);
		
  IF	exp[omCon]<>NIL	THEN BEGIN
    OPM.SymW(F,CHR(SFconst));
    obj:=exp[omCon];
    WHILE	obj<>NIL DO	BEGIN
      OutObj(F,obj);
      OutConst(F,obj.typ.form, obj.conval);
      obj:=obj.sibling
    END;
  END;

  IF	exp[omVar]<>NIL	THEN BEGIN
    OPM.SymW(F,CHR(SFvar));
    obj:=exp[omVar];
    WHILE	obj<>NIL DO BEGIN
      IF	obj.vis=externalR	THEN OPM.SymW(F,CHR(SFreadonly));
      OutObj(F,obj);
      obj:=obj.sibling;
    END;
  END;

  IF	exp[omLProc]<>NIL	THEN BEGIN
    OPM.SymW(F,CHR(SFlproc));
    obj:=exp[omLProc];
    WHILE	obj<>NIL	DO BEGIN
      OutObj(F,obj);
      OutParList(F,obj.link);
      obj:=obj.sibling
    END;
  END;

  IF	exp[omXProc]<>NIL	THEN BEGIN
    OPM.SymW(F,CHR(SFxproc));
    obj:=exp[omXProc];
    WHILE	obj<>NIL DO	BEGIN
      IF obj.sysflag <> 0 THEN BEGIN
        OPM.SymW(F,CHR(SFobjflag));
        OPM.SymW(F,CHR(obj.sysflag))
      END;
      OutObj(F,obj);
      OutParList(F,obj.link);
      obj:=obj.sibling;
    END;
  END;

  IF	exp[omOperator]<>NIL THEN	BEGIN
    OPM.SymW(F,CHR(SFoperator));
    obj:=exp[omOperator];
    WHILE	obj<>NIL	DO BEGIN
      OutObj(F,obj);
      OutParList(F,obj.link);
      obj:=obj.sibling;
    END;
  END;

  IF	exp[omCProc]<>NIL	THEN BEGIN
    OPM.SymW(F,CHR(SFcproc));
    obj:=exp[omCProc];
    WHILE	obj<>NIL	DO BEGIN
      OutObj(F,obj);
      OutParList(F,obj.link);
      OutCProc(F,obj.code.left);
      obj:=obj.sibling
    END;
  END;

  IF	exp[omAlias]<>NIL THEN BEGIN
    OPM.SymW(F,CHR(SFalias));
    obj:=exp[omAlias];
    WHILE	obj<>NIL DO	BEGIN
      OutStruct(F,obj.typ);
      OPM.SymWString(F,obj.name);
      obj:=obj.sibling
    END;
  END;

  IF	exp[omTyp]<>NIL	THEN BEGIN
    obj:=exp[omTyp];
    first:=TRUE;
    WHILE	obj<>NIL DO BEGIN
      IF	obj.typ.sref=0	THEN BEGIN
        IF	first	THEN BEGIN
          OPM.SymW(F,CHR(SFtyp));
          first:=FALSE
        END;
        IF NOT export OR (obj.typ.strobj<>NIL) AND (obj.typ.strobj.vis<>internal)	THEN OutStruct(F,obj.typ);
      END;
      obj:=obj.sibling
    END;
  END;

  OPM.SymWNum(F,SFend)
END;

PROCEDURE OPTExport(VAR modName: STRING; VAR newsf, extsf: BOOLEAN);
VAR
  mods: SHORTINT;
  aliasName: STRING;
BEGIN
  symExtended:=FALSE;
  symNew:=FALSE;
  nofstruc:=0;
  nofemod:=0;
  objectsx:=NIL;
  modNo:=0;
  aliasName:='@self';
  mods:=nofmod;
  Import(aliasName, modName, modName);
  nofmod:=mods;
  IF OPM.noerr THEN BEGIN
    expGlobal:=TRUE;
    CompOldSym(modulesx[0].publics);
    OutScope(OPM.SymF,topScope.right, TRUE);
    expGlobal:=FALSE;
    extsf:=sfpresent AND symExtended;
    newsf:=NOT sfpresent OR symNew;
    OPM.EndSym(modName);
    IF NOT OPM.noerr THEN BEGIN
      err(155);
      newsf:=FALSE;
      extsf:=FALSE
    END;
  END ELSE BEGIN
    newSF:=FALSE;
    extSF:=FALSE
  END;
END;

(* Initialisation *)

PROCEDURE InitStruct(VAR typ: Structs; form, sref: SHORTINT);
BEGIN
  typ := NewStr(form, csBasic);
  typ.ref := form;
  typ.size := OPM.ByteSize;
  typ.sref:=sref;
  predefStruct[sref]:=typ;
  typ.tdadr := 0;
  typ.offset := 0;
  typ.strobj := NewObj();
  typ.fpdone:=-1;
  typ.pvfp:=form;
  typ.pbfp:=form;
  typ.fp:=form;
END;

PROCEDURE EnterIntConst(name: STRING; value: LONGINT);
VAR
  obj: Objects;
BEGIN
  Insert(name, obj);
  obj.conval := NewConst();
  obj.mode := omCon;
  obj.typ := sinttyp;
  obj.conval^.intval := value
END;

PROCEDURE EnterTyp(name: STRING; form: SHORTINT; size: INTEGER; VAR res: Structs; sref: SHORTINT);
VAR
  obj: Objects;
  typ: Structs;
BEGIN
  Insert(name, obj);
  typ := NewStr(form, csBasic);
  obj.mode := omTyp;
  obj.typ := typ;
  obj.vis := external;
  typ.sref:=sref;
  predefStruct[sref]:=typ;
  typ.strobj := obj;
  typ.size := size;
  typ.tdadr := 0;
  typ.offset := 0;
  typ.ref := form;
  res := typ;
  typ.fpdone:=-1;
  typ.pvfp:=size;
  typ.pbfp:=form;
  typ.fp:=form
END;

PROCEDURE EnterTypAlias(name: STRING; typ: Structs);
VAR
  obj: Objects;
BEGIN
  Insert(name, obj);
  obj.mode := omTyp;
  obj.typ := typ;
  obj.vis := external
END;
	
PROCEDURE EnterProc(name: STRING; num: INTEGER);
VAR
  obj: Objects;
BEGIN
  Insert(name, obj);
  obj.mode := omSProc;
  obj.typ := notyp;
  obj.adr := num
END;

PROCEDURE EnterPtr(name: STRING; num: LONGINT);
VAR
  obj: Objects;
BEGIN
  Insert(name, obj);
  obj.mode := omVar;
  obj.typ := ptrtyp;
  obj.adr := num;
  obj.linkadr := num;
  obj.mnolev := 0
END;


PROCEDURE OPTBegin;
BEGIN
	topScope:=NIL;
  SETLENGTH(modulesx, DefMaxImport);
	OpenScope(0, NIL);
	
	InitStruct(undftyp, sfUndef, 0);
	InitStruct(notyp, sfNoTyp, SFtypNoTyp);
  InitStruct(stringtyp, sfString, SFtypString);
  InitStruct(niltyp, sfNilTyp, SFtypNilTyp);
	undftyp.BaseTyp := undftyp;

	(*initialization of module SYSTEM*)
	EnterTyp('BYTE', sfByte, OPM.ByteSize, bytetyp, SFtypByte);
	EnterTyp('PTR', sfPointer, OPM.PointerSize, ptrtyp, SFtypptr);
	EnterProc('ADR', adrfn);
  EnterProc('CC', ccfn);
	EnterProc('LSH', lshfn);
  EnterProc('ROT', rotfn);
	EnterProc('GET', getfn);
  EnterProc('PUT', putfn);
	EnterProc('GETREG', getrfn);
  EnterProc('PUTREG', putrfn);
	EnterProc('BIT', bitfn);
  EnterProc('VAL', valfn);
	EnterProc('NEW', sysnewfn);
  EnterProc('MOVE', movefn);
	EnterProc('PORTOUT', poutfn);
  EnterProc('PORTIN', pinfn);
	EnterProc('STI', stifn);
  EnterProc('CLI', clifn);
	EnterProc('HALT', shalt);
	EnterProc('GET8', get8fn);
  EnterProc('GET16', get16fn);
  EnterProc('GET32', get32fn);
	EnterProc('PUT8', put8fn);
  EnterProc('PUT16', put16fn);
  EnterProc('PUT32', put32fn);
	EnterProc('TYPECODE', typefn);
	
	syslink := topScope.right;
  universe := topScope;
  topScope.right := NIL;

	EnterTyp('CHAR', sfChar, OPM.CharSize, chartyp, SFtypChar);
	EnterTyp('SET', sfSet, OPM.SetSize, settyp, SFtypSet);
	EnterTyp('REAL', sfReal, OPM.RealSize, realtyp, SFtypReal);
	EnterTyp('INTEGER', sfInt, OPM.IntSize, inttyp, SFtypInt);
	EnterTyp('LONGINT',  sfLInt, OPM.LIntSize, linttyp, SFtypLInt);
	EnterTyp('HUGEINT',  sfHInt, OPM.HIntSize, hinttyp, SFtypHInt);
	EnterTyp('LONGREAL', sfLReal, OPM.LRealSize, lrltyp, SFtypLReal);
	EnterTyp('SHORTINT', sfSInt, OPM.SIntSize, sinttyp, SFtypSInt);
	EnterTyp('BOOLEAN', sfBool, OPM.BoolSize, booltyp, SFtypBool);
	EnterTypAlias('PTR',  ptrtyp);

	universe := topScope.right; topScope.right := syslink;		(*add to SYSTEM*)
	EnterIntConst('EAX', 8);
  EnterIntConst('ECX', 9);
	EnterIntConst('EDX', 10);
  EnterIntConst('EBX', 11);
	EnterIntConst('ESP', 12);
  EnterIntConst('EBP', 13);
	EnterIntConst('ESI', 14);
  EnterIntConst('EDI', 15);

	EnterIntConst('AX', 16);
  EnterIntConst('CX', 17);
	EnterIntConst('DX', 18);
  EnterIntConst('BX', 19);
	EnterIntConst('SP', 20);
  EnterIntConst('BP', 21);
	EnterIntConst('SI', 22);
  EnterIntConst('DI', 23);

	EnterIntConst('AL', 24);
  EnterIntConst('CL', 25);
	EnterIntConst('DL', 26);
  EnterIntConst('BL', 27);
	EnterIntConst('AH', 28);
  EnterIntConst('CH', 29);
	EnterIntConst('DH', 30);
  EnterIntConst('BH', 31);

	topScope.right := universe;
  universe := topScope;
	
	EnterProc('HALT', haltfn);
  EnterProc('NEW', newfn);
	EnterProc('ABS', absfn);
  EnterProc('CAP', capfn);
	EnterProc('ORD', ordfn);
  EnterProc('ENTIER', entierfn);
	EnterProc('ODD', oddfn);
  EnterProc('MIN', minfn);
	EnterProc('MAX', maxfn);
  EnterProc('CHR', chrfn);
	EnterProc('SHORT', shortfn);
  EnterProc('LONG', longfn);
	EnterProc('SIZE', sizefn);
  EnterProc('INC', incfn);
	EnterProc('DEC', decfn);
  EnterProc('INCL', inclfn);
  EnterProc('EXCL', exclfn);
	EnterProc('LEN', lenfn);
  EnterProc('COPY', copyfn);
	EnterProc('ASH', ashfn);
  EnterProc('ASSERT', assertfn);

	EnterProc('AWAIT', awaitfn);

	EnterPtr('@SELF', $0);	(* <- Sentinel for the search (it must stop here!! *)
	EnterPtr('SELF', $0);

	strucForm[SFtypPointer]:=sfPointer;
  strucForm[SFtypRecord]:=sfComp;
  strucForm[SFtypProcTyp]:=sfProcTyp;
	strucForm[SFtypDynArr]:=sfComp;
  strucForm[SFtypArray]:=sfComp;
	strucForm[SFtypOpenArr]:=sfComp;
	strucComp[SFtypPointer]:=csBasic;
  strucComp[SFtypRecord]:=csRecord;
  strucComp[SFtypProcTyp]:=csBasic;
	strucComp[SFtypDynArr]:=csDynArr;
  strucComp[SFtypArray]:=csStaticArr;
	strucComp[SFtypOpenArr]:=csOpenArr;
	strucFormSF[sfPointer]:=SFtypPointer;
  strucFormSF[sfProcTyp]:=SFtypProcTyp;
	strucCompSF[csStaticArr]:=SFtypArray;
  strucCompSF[csDynArr]:=SFtypDynArr;
  strucCompSF[csRecord]:=SFtypRecord;
	strucCompSF[csOpenArr]:=SFtypOpenArr;
	
	ToBeFixed:=Structs.Create;
  ToBeFixed.incomplete := TRUE;
END;

END.
